
/*  A Bison parser, made from /home/gray/gnu/radius/radiusd/./rewrite.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	TYPE	257
#define	IF	258
#define	ELSE	259
#define	RETURN	260
#define	WHILE	261
#define	FOR	262
#define	DO	263
#define	BREAK	264
#define	CONTINUE	265
#define	DELETE	266
#define	STRING	267
#define	IDENT	268
#define	NUMBER	269
#define	REFERENCE	270
#define	VARIABLE	271
#define	FUN	272
#define	BUILTIN	273
#define	ATTR	274
#define	BOGUS	275
#define	OR	276
#define	AND	277
#define	MT	278
#define	NM	279
#define	EQ	280
#define	NE	281
#define	LT	282
#define	LE	283
#define	GT	284
#define	GE	285
#define	SHL	286
#define	SHR	287
#define	UMINUS	288
#define	NOT	289
#define	TYPECAST	290

#line 1 "rewrite.y"

/* This file is part of GNU Radius.
   Copyright (C) 2000,2001,2002,2003,2004 Free Software Foundation, Inc.

   Written by Sergey Poznyakoff
  
   GNU Radius is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
  
   GNU Radius is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
  
   You should have received a copy of the GNU General Public License
   along with GNU Radius; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

#if defined(HAVE_CONFIG_H)
# include <config.h>
#endif
#include <stdio.h>
#include <sys/types.h>
#include <ctype.h>
#include <errno.h>

#include <radiusd.h>
#include <setjmp.h>
#include <rewrite.h>
#ifdef USE_SERVER_GUILE 
# include <libguile.h>
# include <radius/radscm.h>	
#endif
        
typedef long RWSTYPE;

/*
 * Generalized list structure
 */
typedef struct rw_list RWLIST;
#define RWLIST(type) \
        type     *next;\
        type     *prev

struct rw_list {
        RWLIST(RWLIST);
};

/*
 * Generalized object 
 */
typedef struct object_t OBJECT ;

#define OBJ(type) \
        RWLIST(type);\
        type    *alloc

struct object_t {
        OBJ(OBJECT);
};

typedef struct {
        size_t   size;        /* Size of an element */
        void     (*free)();   /* deallocator */ 
        OBJECT   *alloc_list; /* list of allocated elements */
} OBUCKET;

        

/* ************************************************************
 * Basic data types
 */

typedef int stkoff_t;             /* Offset on stack */
typedef unsigned int pctr_t;      /* Program counter */

#define RW_REG ('z'-'a'+1)

typedef struct {
        RWSTYPE    reg[RW_REG];       /* Registers */
        #define rA reg[0]
        char       *sA;               /* String accumulator */
        pctr_t     pc;                /* Program counter */  
        
        RWSTYPE    *stack;            /* Stack+heap space */
        int        stacksize;         /* Size of stack */
        int        st;                /* Top of stack */
        int        sb;                /* Stack base */
        int        ht;                /* Top of heap */
        
        int        nmatch;
        regmatch_t *pmatch;

        grad_request_t *req;
        
        jmp_buf    jmp;
} RWMACH;

typedef void (*INSTR)();       /* program instruction */
 
/* Compiled regular expression
 */
typedef struct comp_regex COMP_REGEX;
struct comp_regex {
        OBJ(COMP_REGEX);
        regex_t      regex;    /* compiled regex itself */
        int          nmatch;   /* number of \( ... \) groups */
};

/*
 * Binary Operations
 */
typedef enum {
        Eq,
        Ne,
        Lt,
        Le,
        Gt,
        Ge,
        BAnd,
        BXor,
        BOr,
        And,
        Or,
        Shl,
        Shr,
        Add,
        Sub,
        Mul,
        Div,
        Rem,
        Max_opcode
} Bopcode;

/*
 * Unary operations
 */
typedef enum {
        Neg,
        Not,
        Max_unary
} Uopcode;

/*
 * Matrix types
 */
typedef enum {
        Generic,
        Nop,
        Enter,
        Leave,
        Stop,
        Constant,
        Matchref,
        Variable,
        Unary,
        Binary,
        Cond,
        Asgn,
        Match,
        Coercion,
        Expression,
        Return,
        Jump,
        Branch,
        Target,
        Call,
        Builtin,
        Pop,
        Pusha,
        Popa,
        Attr,
        Attr_asgn,
        Attr_check,
	Attr_delete,
        Max_mtxtype
} Mtxtype;

/*
 * Function parameter
 */
typedef struct parm_t PARAMETER;
struct parm_t {
        PARAMETER   *prev;     /* Previous parameter */
        PARAMETER   *next;     /* Next parameter */
        Datatype    datatype;  /* type */
        stkoff_t    offset;    /* Offset on stack */
};

/*
 * Local variable
 */
typedef struct variable VAR;
struct variable {
        OBJ(VAR);
        VAR       *dcllink;  /* Link to the next variable vithin the
                              * same declaration
                              */
        char      *name;     /* name of the variable */
        int       level;     /* nesting level */
        int       offset;    /* offset on stack */
        Datatype  datatype;  /* type */
        int       constant;  /* true if assigned a constant value */
        Datum     datum;     /* constant value itself */
};

/*
 * Function definition
 */
typedef struct function_def {
        struct function_def *next;
        char       *name;        /* Function name */
        Datatype   rettype;      /* Return type */
        pctr_t     entry;        /* Code entry */
        COMP_REGEX *rx_list;     /* List of compiled regexps */
        int        nparm;        /* Number of parameters */
        PARAMETER  *parm;        /* List of parameters */
        stkoff_t   stack_alloc;  /* required stack allocation */
        grad_locus_t      loc;   /* source location where the function
                                  * was declared
                                  */
} FUNCTION;

#define STACK_BASE 2

/*
 * Built-in function
 */
typedef struct  {
        INSTR    handler;        /* Function itself */
        char     *name;          /* Function name */
        Datatype rettype;        /* Return type */
        char     *parms;         /* coded parameter types */
} builtin_t;

/*
 * Operation matrices
 */
typedef union mtx MTX;
/*
 * All matrices contain the following common fields:
 *    alloc- link to the previously allocated matrix.
 *           It is used at the end of code generation
 *           pass to free all allocated matrices.
 *    next - link to the next matrix in the subexpression
 *    prev - link to the previous matrix in the subexpression
 * Additionally, all expression matrices contain the field
 * `datatype' which contains the data type for this matrix.
 */
#if defined(MAINTAINER_MODE)
# define COMMON_MTX \
        OBJ(MTX);\
        int      id;\
        grad_locus_t    loc;\
        Mtxtype  type;
#else
# define COMMON_MTX \
        OBJ(MTX);\
        grad_locus_t    loc;\
        Mtxtype  type;
#endif
        
#define COMMON_EXPR_MTX \
        COMMON_MTX\
        Datatype datatype;\
        MTX      *uplink;\
        MTX      *arglink;

/*
 * Generic matrix: nothing special
 * Type: Generic
 */
typedef struct {
        COMMON_EXPR_MTX
} GEN_MTX;
/*
 * Constant matrix
 * Type: Constant
 */
typedef struct {
        COMMON_EXPR_MTX
        Datum    datum;     /* Constant value */      
} CONST_MTX;
/*
 * Reference to a previous regexp: corresponds to a \N construct
 * Type: Matchref
 */
typedef struct {
        COMMON_EXPR_MTX
        int      num;       /* Number of \( ... \) to be referenced */
} MATCHREF_MTX;
/*
 * Reference to a variable
 * Type: Variable
 */
typedef struct {
        COMMON_EXPR_MTX
        VAR      *var;      /* Variable being referenced */ 
} VAR_MTX;
/*
 * Unary operation matrix
 * Type: Unary
 */
typedef struct {
        COMMON_EXPR_MTX
        Uopcode  opcode;    /* Operation code */
        MTX      *arg;      /* Argument */
} UN_MTX;
/*
 * Binary operation matrix
 * Type: Binary
 */
typedef struct {
        COMMON_EXPR_MTX
        Bopcode   opcode;   /* Operation code */ 
        MTX      *arg[2];   /* Arguments */ 
} BIN_MTX;
/*
 * Assignment matrix
 * Type: Asgn
 */
typedef struct {
        COMMON_EXPR_MTX
        VAR      *lval;     /* Lvalue */
        MTX      *arg;      /* Rvalue */
} ASGN_MTX;
/*
 * Conditional expression matrix
 * Type: Cond
 */
typedef struct {
        COMMON_MTX
        MTX      *expr;     /* Conditional expression */
        MTX      *if_true;  /* Branch if true */
        MTX      *if_false; /* Branch if false */ 
} COND_MTX;
/*
 * Regexp match
 * Type: Match
 */
typedef struct {
        COMMON_EXPR_MTX
        int        negated; /* Is the match negated ? */
        MTX        *arg;    /* Argument (lhs) */
        COMP_REGEX *rx;     /* Regexp (rhs) */
} MATCH_MTX;
/*
 * Type coercion
 * Type: Coerce
 */
typedef struct {
        COMMON_EXPR_MTX
        MTX      *arg;      /* Argument of the coercion */ 
} COERCE_MTX;
/*
 * Expression
 * Type: Expression
 */
typedef struct {
        COMMON_EXPR_MTX
        MTX      *expr;
} EXPR_MTX;
/*
 * Return from function
 * Type: Return
 */
typedef struct {
        COMMON_EXPR_MTX
        MTX      *expr;     /* Return value */
} RET_MTX;
/*
 * Unconditional branch (jump)
 * Type: Jump
 */
typedef struct {
        COMMON_MTX
        MTX *link;          /* Link to the next jump matrix
                             * (for break and continue matrices)
                             */
        MTX      *dest;     /* Jump destination (usually a NOP matrix) */
} JUMP_MTX;
/*
 * Conditional branch
 * Type: Branch
 */
typedef struct {
        COMMON_MTX
        int      cond;      /* Condition: 1 - equal, 0 - not equal */
        MTX      *dest;     /* Jump destination (usually a NOP matrix) */
} BRANCH_MTX;
/*
 * Stack frame matrix
 * Type: Enter, Leave
 */
typedef struct {
        COMMON_MTX
        stkoff_t  stacksize;/* Required stack size */
} FRAME_MTX;
/*
 * Jump target
 * Type: Target
 */
typedef struct {
        COMMON_MTX
        pctr_t  pc;         /* Target's program counter */
} TGT_MTX;
/*
 * No-op matrix. It is always inserted at the branch destination
 * points. Its purpose is to keep a singly-linked list of jump
 * locations for fixing up jump statements.
 * Type: Nop
 */
typedef struct {
        COMMON_MTX
        TGT_MTX   *tgt;     /* Target list */
        pctr_t     pc;      /* Program counter for backward
                               references */
} NOP_MTX;
/*
 * Function call
 * Type: Call
 */
typedef struct {
        COMMON_EXPR_MTX
        FUNCTION  *fun;     /* Called function */
        int       nargs;    /* Number of arguments */
        MTX       *args;    /* Arguments */
} CALL_MTX;
/*
 * Builtin function call
 * Type: Builtin
 */
typedef struct {
        COMMON_EXPR_MTX
        INSTR     fun;      /* Handler function */
        int       nargs;    /* Number of arguments */   
        MTX       *args;    /* Arguments */
} BTIN_MTX;
/*
 * Attribute matrix
 * Type: Attr, Attr_asgn, Attr_check
 */
typedef struct {
        COMMON_EXPR_MTX
        int       attrno;   /* Attribute number */
	MTX       *index;   /* Index expression */
        MTX       *rval;    /* Rvalue */
} ATTR_MTX;

union mtx {
        GEN_MTX    gen;
        NOP_MTX    nop;
        FRAME_MTX  frame;
        CONST_MTX  cnst;
        MATCHREF_MTX    ref;
        VAR_MTX    var;
        UN_MTX     un;
        BIN_MTX    bin;
        COND_MTX   cond;
        ASGN_MTX   asgn;
        MATCH_MTX  match;
        COERCE_MTX coerce;
        RET_MTX    ret;
        JUMP_MTX   jump;
        BRANCH_MTX branch;
        TGT_MTX    tgt;
        CALL_MTX   call;
        BTIN_MTX   btin;
        ATTR_MTX   attr;
};

/*
 * Stack frame
 */
typedef struct frame_t FRAME;

struct frame_t {
        OBJ(FRAME);
        int       level;        /* nesting level */
        stkoff_t  stack_offset; /* offset in the stack */
};


/* *****************************************************************
 * Static data
 */
/*
 * Stack Frame list
 */
static OBUCKET frame_bkt = { sizeof(FRAME), NULL };
static FRAME *frame_first, *frame_last;
#define curframe frame_last

static int errcnt;         /* Number of errors detected */ 
static FUNCTION *function; /* Function being compiled */
static grad_symtab_t *rewrite_tab;/* Function table */  

static MTX *mtx_first, *mtx_last;  /* Matrix list */
static VAR *var_first, *var_last;  /* Variable list */ 

/*
 * Loops
 */
typedef struct loop_t LOOP;
struct loop_t {
        OBJ(LOOP);
        JUMP_MTX *lp_break;
        JUMP_MTX *lp_cont;
};
static OBUCKET loop_bkt = { sizeof(LOOP), NULL };
static LOOP *loop_first, *loop_last;

void loop_push(MTX *mtx);
void loop_pop();
void loop_fixup(JUMP_MTX *list, MTX *target);
void loop_init();
void loop_free_all();
void loop_unwind_all();

/*
 * Lexical analyzer stuff
 */
static FILE *infile;               /* Input file */ 
static grad_locus_t locus;         /* Input location */

static char *inbuf;                /* Input string */
static char *curp;                 /* Current pointer */
 
static int   rw_yyeof;                /* rised when EOF is encountered */ 
static struct obstack input_stk;   /* Symbol stack */ 

static Datatype return_type = Undefined;
                                   /* Data type of the topmost expression. */

static int regcomp_flags = 0;      /* Flags to be used with regcomps */

#define regex_init() regcomp_flags = 0
 
/* Runtime */
static size_t rewrite_stack_size = 4096;  /* Size of stack+heap */
static RWSTYPE *runtime_stack;
static RWMACH mach;

/* Default domain for gettext functions. It is initialized to PACKAGE
   by default */
static char *default_gettext_domain;
 

/* ***************************************************************
 * Function declarations
 */

/*
 * Lexical analyzer
 */
static int rw_yylex(); 
static void rw_yysync();
static int rw_yyerror(char *s);
 
/*
 * Frames
 */
static void frame_init();
static void frame_push();
static void frame_pop();
static void frame_unwind_all();
static void frame_free_all();
/*
 * Variables
 */
static void var_init();
static VAR * var_alloc(Datatype type, char *name, int grow);
static void var_unwind_level();
static void var_unwind_all();
static void var_type(Datatype type, VAR *var);
static void var_free_all();
static VAR *var_lookup(char *name);
/*
 * Matrices
 */
static void mtx_init();
static void mtx_free_all();
static void mtx_unwind_all();
static MTX * mtx_cur();
static MTX * mtx_nop();
static MTX * mtx_jump();
static MTX * mtx_frame(Mtxtype type, stkoff_t stksize);
static MTX * mtx_stop();
static MTX * mtx_pop();
static MTX * mtx_return();
static MTX * mtx_alloc(Mtxtype type);
static MTX * mtx_const(Datatype type, void *data);
static MTX * mtx_ref(int num);
static MTX * mtx_var(VAR *var);
static MTX * mtx_asgn(VAR *var, MTX *arg);
static MTX * mtx_bin(Bopcode opcode, MTX *arg1, MTX *arg2);
static MTX * mtx_un(Uopcode opcode, MTX *arg);
static MTX * mtx_match(int negated, MTX *mtx, COMP_REGEX *);
static MTX * mtx_cond(MTX *cond, MTX *if_true, MTX *if_false);
static MTX * mtx_coerce(Datatype type, MTX *arg);
static MTX * mtx_call(FUNCTION *fun, MTX *args);
static MTX * mtx_builtin(builtin_t *bin, MTX *args);
static MTX * mtx_attr(grad_dict_attr_t *attr, MTX *index);
static MTX * mtx_attr_asgn(grad_dict_attr_t *attr, MTX *index, MTX *rval);
static MTX * mtx_attr_check(grad_dict_attr_t *attr, MTX *index);
static MTX * mtx_attr_delete(grad_dict_attr_t *attr, MTX *index);

static MTX * coerce(MTX  *arg, Datatype type);
/*
 * Regular expressions
 */
static COMP_REGEX * rx_alloc(regex_t  *regex, int nmatch);
static void rx_free(COMP_REGEX *rx);
static COMP_REGEX * compile_regexp(char *str);
/*
 * Functions
 */
static FUNCTION * function_install(FUNCTION *fun);
static int  function_free(FUNCTION *fun);
static void function_delete();
static void function_cleanup();
/*
 * Built-in functions
 */
static builtin_t * builtin_lookup(char *name);

/*
 * Code optimizer and generator
 */
static int optimize();
static pctr_t codegen();
static void code_init();
static void code_check();

/*
 * Auxiliary and debugging functions
 */
static void debug_dump_code();
static const char * datatype_str_nom(Datatype type);
static const char * datatype_str_acc(Datatype type);
static const char * datatype_str_abl(Datatype type);
static Datatype attr_datatype(int type);

/*
 * Run-Time
 */
static void gc();
static void run(pctr_t pc);
static int run_init(pctr_t pc, grad_request_t *req);
static int rw_error(const char *msg);
static int rw_error_free(char *msg);
 
/* These used to lock/unlock access to rw_code array. Now this is
   not needed. However, I left the placeholders for a while... */
#define rw_code_lock() 
#define rw_code_unlock()

#define AVPLIST(m) ((m)->req ? (m)->req->avlist : NULL)

#line 664 "rewrite.y"
typedef union {
        int   number;
        int   type;
        VAR   *var;
        MTX   *mtx;
        FUNCTION  *fun;
        builtin_t *btin;
        grad_dict_attr_t *attr;
        struct {
                MTX *arg_first;
                MTX *arg_last;
        } arg;
        struct {
                int nmatch;
                regex_t regex;
        } rx;
        char  *string;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		166
#define	YYFLAG		-32768
#define	YYNTBASE	52

#define YYTRANSLATE(x) ((unsigned)(x) <= 290 ? rw_yytranslate[x] : 78)

static const char rw_yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,    42,    29,     2,    50,
    51,    40,    38,    49,    39,     2,    41,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    48,     2,
    22,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,    28,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    46,    27,    47,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    23,    24,    25,    26,    30,
    31,    32,    33,    34,    35,    36,    37,    43,    44,    45
};

#if YYDEBUG != 0
static const short rw_yyprhs[] = {     0,
     0,     2,     4,     6,     8,    11,    14,    19,    23,    27,
    29,    32,    34,    36,    38,    40,    43,    47,    49,    53,
    56,    60,    62,    66,    69,    70,    72,    74,    78,    80,
    82,    85,    89,    92,    96,   102,   106,   110,   111,   118,
   121,   124,   128,   135,   137,   139,   141,   145,   147,   149,
   151,   153,   155,   159,   161,   166,   169,   175,   179,   186,
   191,   196,   200,   204,   208,   212,   216,   220,   224,   228,
   232,   236,   240,   244,   247,   250,   253,   257,   262,   266,
   270,   274,   278,   282,   286,   290
};

static const short rw_yyrhs[] = {    53,
     0,    54,     0,    77,     0,    55,     0,    54,    55,     0,
    54,     1,     0,    56,    57,    70,    58,     0,     3,    14,
    64,     0,     3,    18,    64,     0,    59,     0,    59,    61,
     0,    60,     0,    46,     0,    47,     0,    62,     0,    61,
    62,     0,     3,    63,    48,     0,    14,     0,    63,    49,
    14,     0,    50,    51,     0,    50,    65,    51,     0,    66,
     0,    65,    49,    66,     0,     3,    14,     0,     0,    68,
     0,    69,     0,    68,    49,    69,     0,    77,     0,    71,
     0,    70,    71,     0,    57,    70,    58,     0,    77,    48,
     0,     4,    76,    71,     0,     4,    76,    71,    75,    71,
     0,     6,    77,    48,     0,    73,    76,    71,     0,     0,
    74,    71,    72,     7,    76,    48,     0,    10,    48,     0,
    11,    48,     0,    12,    20,    48,     0,    12,    20,    50,
    77,    51,    48,     0,     7,     0,     9,     0,     5,     0,
    50,    77,    51,     0,    15,     0,    13,     0,    16,     0,
    17,     0,    14,     0,    17,    22,    77,     0,    20,     0,
    20,    50,    77,    51,     0,    40,    20,     0,    40,    20,
    50,    77,    51,     0,    20,    22,    77,     0,    20,    50,
    77,    51,    22,    77,     0,    18,    50,    67,    51,     0,
    19,    50,    67,    51,     0,    77,    38,    77,     0,    77,
    39,    77,     0,    77,    40,    77,     0,    77,    41,    77,
     0,    77,    42,    77,     0,    77,    27,    77,     0,    77,
    29,    77,     0,    77,    28,    77,     0,    77,    36,    77,
     0,    77,    37,    77,     0,    77,    24,    77,     0,    77,
    23,    77,     0,    39,    77,     0,    38,    77,     0,    44,
    77,     0,    50,    77,    51,     0,    50,     3,    51,    77,
     0,    77,    30,    77,     0,    77,    31,    77,     0,    77,
    32,    77,     0,    77,    33,    77,     0,    77,    34,    77,
     0,    77,    35,    77,     0,    77,    25,    13,     0,    77,
    26,    13,     0
};

#endif

#if YYDEBUG != 0
static const short rw_yyrline[] = { 0,
   714,   723,   727,   751,   752,   753,   770,   796,   835,   846,
   847,   850,   853,   859,   870,   871,   874,   880,   885,   896,
   900,   906,   911,   918,   927,   931,   937,   942,   950,   956,
   957,   960,   964,   969,   974,   981,   986,  1002,  1002,  1021,
  1035,  1048,  1052,  1058,  1065,  1072,  1080,  1091,  1095,  1099,
  1103,  1107,  1113,  1117,  1121,  1125,  1129,  1133,  1137,  1141,
  1145,  1149,  1153,  1157,  1161,  1165,  1169,  1173,  1177,  1181,
  1185,  1189,  1193,  1197,  1201,  1205,  1209,  1213,  1217,  1221,
  1225,  1229,  1233,  1237,  1241,  1250
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const rw_yytname[] = {   "$","error","$undefined.","TYPE","IF",
"ELSE","RETURN","WHILE","FOR","DO","BREAK","CONTINUE","DELETE","STRING","IDENT",
"NUMBER","REFERENCE","VARIABLE","FUN","BUILTIN","ATTR","BOGUS","'='","OR","AND",
"MT","NM","'|'","'^'","'&'","EQ","NE","LT","LE","GT","GE","SHL","SHR","'+'",
"'-'","'*'","'/'","'%'","UMINUS","NOT","TYPECAST","'{'","'}'","';'","','","'('",
"')'","program","input","dcllist","decl","fundecl","begin","end","obrace","cbrace",
"autodcl","autovar","varlist","dclparm","parmlist","parm","args","arglist","arg",
"list","stmt","@1","while","do","else","cond","expr", NULL
};
#endif

static const short rw_yyr1[] = {     0,
    52,    53,    53,    54,    54,    54,    55,    56,    56,    57,
    57,    58,    59,    60,    61,    61,    62,    63,    63,    64,
    64,    65,    65,    66,    67,    67,    68,    68,    69,    70,
    70,    71,    71,    71,    71,    71,    71,    72,    71,    71,
    71,    71,    71,    73,    74,    75,    76,    77,    77,    77,
    77,    77,    77,    77,    77,    77,    77,    77,    77,    77,
    77,    77,    77,    77,    77,    77,    77,    77,    77,    77,
    77,    77,    77,    77,    77,    77,    77,    77,    77,    77,
    77,    77,    77,    77,    77,    77
};

static const short rw_yyr2[] = {     0,
     1,     1,     1,     1,     2,     2,     4,     3,     3,     1,
     2,     1,     1,     1,     1,     2,     3,     1,     3,     2,
     3,     1,     3,     2,     0,     1,     1,     3,     1,     1,
     2,     3,     2,     3,     5,     3,     3,     0,     6,     2,
     2,     3,     6,     1,     1,     1,     3,     1,     1,     1,
     1,     1,     3,     1,     4,     2,     5,     3,     6,     4,
     4,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     2,     2,     2,     3,     4,     3,     3,
     3,     3,     3,     3,     3,     3
};

static const short rw_yydefact[] = {     0,
     0,    49,    52,    48,    50,    51,     0,     0,    54,     0,
     0,     0,     0,     0,     1,     0,     4,     0,     3,     0,
     0,     0,    25,    25,     0,     0,    75,    74,    56,    76,
     0,     0,     6,     5,    13,     0,    10,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     8,     9,
    53,     0,    26,    27,    29,     0,    58,     0,     0,     0,
    77,     0,     0,    44,    45,     0,     0,     0,     0,     0,
    30,     0,     0,     0,     0,    11,    15,    73,    72,    85,
    86,    67,    69,    68,    79,    80,    81,    82,    83,    84,
    70,    71,    62,    63,    64,    65,    66,     0,    20,     0,
    22,    60,     0,    61,    55,     0,    78,     0,     0,     0,
    40,    41,     0,     0,    14,     7,    12,    31,     0,    38,
    33,    18,     0,    16,    24,     0,    21,    28,     0,    57,
     0,    34,    36,    42,     0,    32,    37,     0,    17,     0,
    23,    59,    47,    46,     0,     0,     0,    19,    35,     0,
     0,    43,    39,     0,     0,     0
};

static const short rw_yydefgoto[] = {   164,
    15,    16,    17,    18,    79,   126,    37,   127,    86,    87,
   133,    59,   110,   111,    62,    63,    64,    80,    81,   148,
    82,    83,   155,   119,    84
};

static const short rw_yypact[] = {    65,
    14,-32768,-32768,-32768,-32768,    18,   -19,    -9,   -21,   205,
   205,    38,   205,   108,-32768,    33,-32768,    13,   430,    22,
    22,   205,   205,   205,   205,   205,-32768,-32768,    24,-32768,
    50,   233,-32768,-32768,-32768,   167,    61,   205,   205,    62,
    93,   205,   205,   205,   205,   205,   205,   205,   205,   205,
   205,   205,   205,   205,   205,   205,   205,     9,-32768,-32768,
   430,    56,    59,-32768,   430,    63,   430,   262,   205,   205,
-32768,    60,   205,-32768,-32768,    64,    68,    97,   167,   150,
-32768,    60,   167,   378,   105,    61,-32768,   449,   467,-32768,
-32768,    58,   197,   480,   491,   491,   -33,   -33,   -33,   -33,
   -23,   -23,    21,    21,-32768,-32768,-32768,   106,-32768,   -14,
-32768,-32768,   205,-32768,   107,   291,-32768,   205,   167,   404,
-32768,-32768,    17,   150,-32768,-32768,-32768,-32768,   167,-32768,
-32768,-32768,   -28,-32768,-32768,   127,-32768,-32768,   205,-32768,
   320,   126,-32768,-32768,   205,-32768,-32768,   125,-32768,   119,
-32768,   430,-32768,-32768,   167,   349,    60,-32768,-32768,    86,
    87,-32768,-32768,   136,   137,-32768
};

static const short rw_yypgoto[] = {-32768,
-32768,-32768,   122,-32768,   123,    16,-32768,-32768,-32768,    57,
-32768,   121,-32768,     8,   129,-32768,    36,    71,   -53,-32768,
-32768,-32768,-32768,   -80,     0
};


#define	YYLAST		533


static const short rw_yytable[] = {    19,
    25,   129,    51,    52,    53,    54,    55,    56,    57,    27,
    28,   108,    30,    32,    53,    54,    55,    56,    57,   149,
   150,    61,    65,    65,    67,    68,   128,    20,    26,   130,
    23,    21,    -2,    33,   136,     1,   137,    88,    89,    22,
    24,    92,    93,    94,    95,    96,    97,    98,    99,   100,
   101,   102,   103,   104,   105,   106,   107,    29,    35,   109,
    55,    56,    57,    85,   144,   142,   145,     1,   116,   117,
   128,    58,   120,    69,    90,   147,   161,     2,     3,     4,
     5,     6,     7,     8,     9,    43,    44,    45,    46,    47,
    48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
    70,   159,    10,    11,    12,    91,   112,   113,    13,   118,
    31,   121,    65,   114,    14,   122,   123,   141,   132,   135,
     2,     3,     4,     5,     6,     7,     8,     9,   139,   108,
   154,   157,   158,   162,   163,   165,   166,    34,   152,   146,
    36,    60,   134,   151,   156,    10,    11,    12,   138,   124,
     0,    13,    66,    72,     0,    73,    74,    14,    75,    76,
    77,    78,     2,     3,     4,     5,     6,     7,     8,     9,
    72,     0,    73,    74,     0,    75,    76,    77,    78,     2,
     3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
     0,     0,     0,    13,     0,    35,   125,     0,     0,    14,
     0,     0,     0,     0,    10,    11,    12,     0,     0,     0,
    13,     0,    35,     0,     0,     0,    14,     2,     3,     4,
     5,     6,     7,     8,     9,    44,    45,    46,    47,    48,
    49,    50,    51,    52,    53,    54,    55,    56,    57,     0,
     0,     0,    10,    11,    12,     0,     0,     0,    13,     0,
     0,     0,     0,     0,    14,    38,    39,    40,    41,    42,
    43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
    53,    54,    55,    56,    57,     0,     0,     0,     0,     0,
     0,     0,     0,    71,    38,    39,    40,    41,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
    54,    55,    56,    57,     0,     0,     0,     0,     0,     0,
     0,     0,   115,    38,    39,    40,    41,    42,    43,    44,
    45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
    55,    56,    57,     0,     0,     0,     0,     0,     0,     0,
     0,   140,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,     0,     0,     0,     0,     0,     0,     0,     0,
   153,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,     0,     0,     0,     0,     0,     0,     0,     0,   160,
    38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
    48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
     0,     0,     0,     0,     0,   131,    38,    39,    40,    41,
    42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
    52,    53,    54,    55,    56,    57,     0,     0,     0,     0,
     0,   143,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    40,    41,    42,    43,    44,    45,    46,    47,    48,
    49,    50,    51,    52,    53,    54,    55,    56,    57,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    47,    48,    49,    50,    51,    52,    53,    54,
    55,    56,    57
};

static const short rw_yycheck[] = {     0,
    22,    82,    36,    37,    38,    39,    40,    41,    42,    10,
    11,     3,    13,    14,    38,    39,    40,    41,    42,    48,
    49,    22,    23,    24,    25,    26,    80,    14,    50,    83,
    50,    18,     0,     1,    49,     3,    51,    38,    39,    22,
    50,    42,    43,    44,    45,    46,    47,    48,    49,    50,
    51,    52,    53,    54,    55,    56,    57,    20,    46,    51,
    40,    41,    42,     3,    48,   119,    50,     3,    69,    70,
   124,    50,    73,    50,    13,   129,   157,    13,    14,    15,
    16,    17,    18,    19,    20,    28,    29,    30,    31,    32,
    33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
    51,   155,    38,    39,    40,    13,    51,    49,    44,    50,
     3,    48,   113,    51,    50,    48,    20,   118,    14,    14,
    13,    14,    15,    16,    17,    18,    19,    20,    22,     3,
     5,     7,    14,    48,    48,     0,     0,    16,   139,   124,
    18,    21,    86,   136,   145,    38,    39,    40,   113,    79,
    -1,    44,    24,     4,    -1,     6,     7,    50,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
     4,    -1,     6,     7,    -1,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    38,    39,    40,
    -1,    -1,    -1,    44,    -1,    46,    47,    -1,    -1,    50,
    -1,    -1,    -1,    -1,    38,    39,    40,    -1,    -1,    -1,
    44,    -1,    46,    -1,    -1,    -1,    50,    13,    14,    15,
    16,    17,    18,    19,    20,    29,    30,    31,    32,    33,
    34,    35,    36,    37,    38,    39,    40,    41,    42,    -1,
    -1,    -1,    38,    39,    40,    -1,    -1,    -1,    44,    -1,
    -1,    -1,    -1,    -1,    50,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
    38,    39,    40,    41,    42,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    51,    23,    24,    25,    26,    27,    28,
    29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
    39,    40,    41,    42,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    51,    23,    24,    25,    26,    27,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
    40,    41,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    51,    23,    24,    25,    26,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    51,    23,    24,    25,    26,    27,    28,    29,    30,    31,
    32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,
    23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
    33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
    -1,    -1,    -1,    -1,    -1,    48,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    -1,    -1,    -1,    -1,
    -1,    48,    23,    24,    25,    26,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    42,    24,    25,    26,    27,    28,    29,    30,    31,
    32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
    42,    25,    26,    27,    28,    29,    30,    31,    32,    33,
    34,    35,    36,    37,    38,    39,    40,    41,    42,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    42,    32,    33,    34,    35,    36,    37,    38,    39,
    40,    41,    42
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define rw_yyerrok		(rw_yyerrstatus = 0)
#define rw_yyclearin	(rw_yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto rw_yyacceptlab
#define YYABORT 	goto rw_yyabortlab
#define YYERROR		goto rw_yyerrlab1
/* Like YYERROR except do call rw_yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto rw_yyerrlab
#define YYRECOVERING()  (!!rw_yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (rw_yychar == YYEMPTY && rw_yylen == 1)				\
    { rw_yychar = (token), rw_yylval = (value);			\
      rw_yychar1 = YYTRANSLATE (rw_yychar);				\
      YYPOPSTACK;						\
      goto rw_yybackup;						\
    }								\
  else								\
    { rw_yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		rw_yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		rw_yylex(&rw_yylval, &rw_yylloc, YYLEX_PARAM)
#else
#define YYLEX		rw_yylex(&rw_yylval, &rw_yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		rw_yylex(&rw_yylval, YYLEX_PARAM)
#else
#define YYLEX		rw_yylex(&rw_yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	rw_yychar;			/*  the lookahead symbol		*/
YYSTYPE	rw_yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE rw_yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int rw_yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int rw_yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __rw_yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __rw_yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__rw_yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__rw_yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into rw_yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int rw_yyparse (void *);
#else
int rw_yyparse (void);
#endif
#endif

int
rw_yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int rw_yystate;
  register int rw_yyn;
  register short *rw_yyssp;
  register YYSTYPE *rw_yyvsp;
  int rw_yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int rw_yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	rw_yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE rw_yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *rw_yyss = rw_yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *rw_yyvs = rw_yyvsa;	/*  to allow rw_yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE rw_yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *rw_yyls = rw_yylsa;
  YYLTYPE *rw_yylsp;

#define YYPOPSTACK   (rw_yyvsp--, rw_yyssp--, rw_yylsp--)
#else
#define YYPOPSTACK   (rw_yyvsp--, rw_yyssp--)
#endif

  int rw_yystacksize = YYINITDEPTH;
  int rw_yyfree_stacks = 0;

#ifdef YYPURE
  int rw_yychar;
  YYSTYPE rw_yylval;
  int rw_yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE rw_yylloc;
#endif
#endif

  YYSTYPE rw_yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int rw_yylen;

#if YYDEBUG != 0
  if (rw_yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  rw_yystate = 0;
  rw_yyerrstatus = 0;
  rw_yynerrs = 0;
  rw_yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  rw_yyssp = rw_yyss - 1;
  rw_yyvsp = rw_yyvs;
#ifdef YYLSP_NEEDED
  rw_yylsp = rw_yyls;
#endif

/* Push a new state, which is found in  rw_yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
rw_yynewstate:

  *++rw_yyssp = rw_yystate;

  if (rw_yyssp >= rw_yyss + rw_yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *rw_yyvs1 = rw_yyvs;
      short *rw_yyss1 = rw_yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *rw_yyls1 = rw_yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = rw_yyssp - rw_yyss + 1;

#ifdef rw_yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if rw_yyoverflow is a macro.  */
      rw_yyoverflow("parser stack overflow",
		 &rw_yyss1, size * sizeof (*rw_yyssp),
		 &rw_yyvs1, size * sizeof (*rw_yyvsp),
		 &rw_yyls1, size * sizeof (*rw_yylsp),
		 &rw_yystacksize);
#else
      rw_yyoverflow("parser stack overflow",
		 &rw_yyss1, size * sizeof (*rw_yyssp),
		 &rw_yyvs1, size * sizeof (*rw_yyvsp),
		 &rw_yystacksize);
#endif

      rw_yyss = rw_yyss1; rw_yyvs = rw_yyvs1;
#ifdef YYLSP_NEEDED
      rw_yyls = rw_yyls1;
#endif
#else /* no rw_yyoverflow */
      /* Extend the stack our own way.  */
      if (rw_yystacksize >= YYMAXDEPTH)
	{
	  rw_yyerror("parser stack overflow");
	  if (rw_yyfree_stacks)
	    {
	      free (rw_yyss);
	      free (rw_yyvs);
#ifdef YYLSP_NEEDED
	      free (rw_yyls);
#endif
	    }
	  return 2;
	}
      rw_yystacksize *= 2;
      if (rw_yystacksize > YYMAXDEPTH)
	rw_yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      rw_yyfree_stacks = 1;
#endif
      rw_yyss = (short *) YYSTACK_ALLOC (rw_yystacksize * sizeof (*rw_yyssp));
      __rw_yy_memcpy ((char *)rw_yyss, (char *)rw_yyss1,
		   size * (unsigned int) sizeof (*rw_yyssp));
      rw_yyvs = (YYSTYPE *) YYSTACK_ALLOC (rw_yystacksize * sizeof (*rw_yyvsp));
      __rw_yy_memcpy ((char *)rw_yyvs, (char *)rw_yyvs1,
		   size * (unsigned int) sizeof (*rw_yyvsp));
#ifdef YYLSP_NEEDED
      rw_yyls = (YYLTYPE *) YYSTACK_ALLOC (rw_yystacksize * sizeof (*rw_yylsp));
      __rw_yy_memcpy ((char *)rw_yyls, (char *)rw_yyls1,
		   size * (unsigned int) sizeof (*rw_yylsp));
#endif
#endif /* no rw_yyoverflow */

      rw_yyssp = rw_yyss + size - 1;
      rw_yyvsp = rw_yyvs + size - 1;
#ifdef YYLSP_NEEDED
      rw_yylsp = rw_yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (rw_yydebug)
	fprintf(stderr, "Stack size increased to %d\n", rw_yystacksize);
#endif

      if (rw_yyssp >= rw_yyss + rw_yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (rw_yydebug)
    fprintf(stderr, "Entering state %d\n", rw_yystate);
#endif

  goto rw_yybackup;
 rw_yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* rw_yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  rw_yyn = rw_yypact[rw_yystate];
  if (rw_yyn == YYFLAG)
    goto rw_yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* rw_yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (rw_yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (rw_yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      rw_yychar = YYLEX;
    }

  /* Convert token to internal form (in rw_yychar1) for indexing tables with */

  if (rw_yychar <= 0)		/* This means end of input. */
    {
      rw_yychar1 = 0;
      rw_yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (rw_yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      rw_yychar1 = YYTRANSLATE(rw_yychar);

#if YYDEBUG != 0
      if (rw_yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", rw_yychar, rw_yytname[rw_yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, rw_yychar, rw_yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  rw_yyn += rw_yychar1;
  if (rw_yyn < 0 || rw_yyn > YYLAST || rw_yycheck[rw_yyn] != rw_yychar1)
    goto rw_yydefault;

  rw_yyn = rw_yytable[rw_yyn];

  /* rw_yyn is what to do for this token type in this state.
     Negative => reduce, -rw_yyn is rule number.
     Positive => shift, rw_yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (rw_yyn < 0)
    {
      if (rw_yyn == YYFLAG)
	goto rw_yyerrlab;
      rw_yyn = -rw_yyn;
      goto rw_yyreduce;
    }
  else if (rw_yyn == 0)
    goto rw_yyerrlab;

  if (rw_yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (rw_yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", rw_yychar, rw_yytname[rw_yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (rw_yychar != YYEOF)
    rw_yychar = YYEMPTY;

  *++rw_yyvsp = rw_yylval;
#ifdef YYLSP_NEEDED
  *++rw_yylsp = rw_yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (rw_yyerrstatus) rw_yyerrstatus--;

  rw_yystate = rw_yyn;
  goto rw_yynewstate;

/* Do the default action for the current state.  */
rw_yydefault:

  rw_yyn = rw_yydefact[rw_yystate];
  if (rw_yyn == 0)
    goto rw_yyerrlab;

/* Do a reduction.  rw_yyn is the number of a rule to reduce with.  */
rw_yyreduce:
  rw_yylen = rw_yyr2[rw_yyn];
  if (rw_yylen > 0)
    rw_yyval = rw_yyvsp[1-rw_yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (rw_yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       rw_yyn, rw_yyrline[rw_yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = rw_yyprhs[rw_yyn]; rw_yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", rw_yytname[rw_yyrhs[i]]);
      fprintf (stderr, " -> %s\n", rw_yytname[rw_yyr1[rw_yyn]]);
    }
#endif


  switch (rw_yyn) {

case 1:
#line 715 "rewrite.y"
{
                  var_free_all();
                  loop_free_all();
                  frame_free_all();
                  mtx_free_all();
          ;
    break;}
case 2:
#line 724 "rewrite.y"
{
		  return_type = Undefined;
	  ;
    break;}
case 3:
#line 728 "rewrite.y"
{
		  FUNCTION fmain;

                  if (errcnt) {
                          YYERROR;
                  }
		  
		  mtx_return(rw_yyvsp[0].mtx);
                  
		  memset(&fmain, 0, sizeof(fmain));
		  fmain.name = "main";
		  fmain.rettype = return_type = rw_yyvsp[0].mtx->gen.datatype;
		  function = &fmain;

                  if (optimize() == 0) {
                          codegen();
                          if (errcnt) {
                                  YYERROR;
                          }
                  }
          ;
    break;}
case 6:
#line 754 "rewrite.y"
{
                  /* Roll back all changes done so far */
                  var_unwind_all();
                  loop_unwind_all();
                  frame_unwind_all();
                  mtx_unwind_all();
                  function_delete();
                  /* Synchronize input after error */
                  rw_yysync();
                  /* Clear input and error condition */
                  rw_yyclearin;
                  rw_yyerrok;
                  errcnt = 0;
          ;
    break;}
case 7:
#line 771 "rewrite.y"
{
                  if (errcnt) {
                          function_delete();
                          YYERROR;
                  }
                  
                  if (optimize() == 0) {
                          codegen();
                          if (errcnt) {
                                  function_delete();
                                  YYERROR;
                          }
                  } else {
                          function_delete();
                  }
                  
                  /* clean up things */
                  var_unwind_all();
                  loop_unwind_all();
                  frame_unwind_all();
                  mtx_unwind_all();
                  function_cleanup();
          ;
    break;}
case 8:
#line 797 "rewrite.y"
{
                  VAR *var;
                  PARAMETER *last, *parm;
                  FUNCTION f;
                  
                  if (errcnt)
                          YYERROR;
                  
                  memset(&f, 0, sizeof(f));
                  f.name    = rw_yyvsp[-1].string;
                  f.rettype = rw_yyvsp[-2].type;
                  f.entry   = 0;
                  f.loc     = locus;
                  
                  f.nparm   = 0;
                  f.parm    = NULL;

                  /* Count number of parameters */
                  for (var = rw_yyvsp[0].var; var; var = var->next) 
                          f.nparm++;

                  f.parm = last = NULL;
                  for (var = rw_yyvsp[0].var; var; var = var->next) {
                          parm = grad_emalloc(sizeof(*parm));
                          parm->datatype = var->datatype;
                          var->offset = -(STACK_BASE+
                                          f.nparm - var->offset);
                          parm->offset   = var->offset;
                          parm->prev     = last;
                          parm->next     = NULL;
                          if (f.parm == NULL)
                                  f.parm = parm;
                          else 
                                  last->next = parm;
                          last = parm;
                  }
                  function = function_install(&f);
          ;
    break;}
case 9:
#line 836 "rewrite.y"
{
		  grad_log_loc(L_ERR, &locus,
			       _("redefinition of function `%s'"), rw_yyvsp[-1].fun->name);
		  grad_log_loc(L_ERR, &rw_yyvsp[-1].fun->loc,
			       _("previously defined here"));
		  errcnt++;
		  YYERROR;
          ;
    break;}
case 13:
#line 854 "rewrite.y"
{
                  frame_push();
          ;
    break;}
case 14:
#line 860 "rewrite.y"
{
                  var_unwind_level();
                  frame_pop();
          ;
    break;}
case 17:
#line 875 "rewrite.y"
{
                  var_type(rw_yyvsp[-2].type, rw_yyvsp[-1].var);
          ;
    break;}
case 18:
#line 881 "rewrite.y"
{
                  rw_yyval.var = var_alloc(Undefined, rw_yyvsp[0].string, +1);
                  rw_yyval.var->dcllink = NULL;
          ;
    break;}
case 19:
#line 886 "rewrite.y"
{
                  VAR *var = var_alloc(Undefined, rw_yyvsp[0].string, +1);
                  var->dcllink = rw_yyvsp[-2].var;
                  rw_yyval.var = var;
          ;
    break;}
case 20:
#line 897 "rewrite.y"
{
                  rw_yyval.var = NULL;
          ;
    break;}
case 21:
#line 901 "rewrite.y"
{
                  rw_yyval.var = rw_yyvsp[-1].var;
          ;
    break;}
case 22:
#line 907 "rewrite.y"
{
                  /*FIXME*/
                  /*$$->dcllink = NULL;*/
          ;
    break;}
case 23:
#line 912 "rewrite.y"
{
                  /*$1->dcllink = $3;*/
                  rw_yyval.var = rw_yyvsp[-2].var;
          ;
    break;}
case 24:
#line 919 "rewrite.y"
{
                  rw_yyval.var = var_alloc(rw_yyvsp[-1].type, rw_yyvsp[0].string, +1);
          ;
    break;}
case 25:
#line 928 "rewrite.y"
{
                  rw_yyval.mtx = NULL;
          ;
    break;}
case 26:
#line 932 "rewrite.y"
{
                  rw_yyval.mtx = rw_yyvsp[0].arg.arg_first;
          ;
    break;}
case 27:
#line 938 "rewrite.y"
{
                  rw_yyvsp[0].mtx->gen.arglink = NULL;
                  rw_yyval.arg.arg_first = rw_yyval.arg.arg_last = rw_yyvsp[0].mtx;
          ;
    break;}
case 28:
#line 943 "rewrite.y"
{
                  rw_yyvsp[-2].arg.arg_last->gen.arglink = rw_yyvsp[0].mtx;
                  rw_yyvsp[-2].arg.arg_last = rw_yyvsp[0].mtx;
                  rw_yyval.arg = rw_yyvsp[-2].arg;
          ;
    break;}
case 32:
#line 961 "rewrite.y"
{
                  rw_yyval.mtx = rw_yyvsp[-1].mtx;
          ;
    break;}
case 33:
#line 965 "rewrite.y"
{
                  mtx_stop();
                  mtx_pop();
          ;
    break;}
case 34:
#line 970 "rewrite.y"
{
                  rw_yyvsp[-1].mtx->cond.if_false = mtx_nop();
                  rw_yyval.mtx = mtx_cur();
          ;
    break;}
case 35:
#line 975 "rewrite.y"
{
                  mtx_stop();
                  rw_yyvsp[-3].mtx->cond.if_false = rw_yyvsp[-1].mtx;
                  rw_yyvsp[-1].mtx->nop.prev->jump.dest = mtx_nop();
                  rw_yyval.mtx = mtx_cur();
          ;
    break;}
case 36:
#line 982 "rewrite.y"
{
                  /*mtx_stop();*/
                  rw_yyval.mtx = mtx_return(rw_yyvsp[-1].mtx);
          ;
    break;}
case 37:
#line 987 "rewrite.y"
{
                  MTX *mtx;
                  
                  mtx_stop();
                  mtx = mtx_jump();
                  mtx->jump.dest = rw_yyvsp[-2].mtx;
                  rw_yyvsp[-1].mtx->cond.if_false = mtx_nop();
                  rw_yyval.mtx = mtx_cur();
                  
                  /* Fixup possible breaks */
                  loop_fixup(loop_last->lp_break, rw_yyval.mtx);
                  /* Fixup possible continues */
                  loop_fixup(loop_last->lp_cont, rw_yyvsp[-2].mtx);
                  loop_pop();
          ;
    break;}
case 38:
#line 1002 "rewrite.y"
{ rw_yyval.mtx = mtx_nop(); ;
    break;}
case 39:
#line 1003 "rewrite.y"
{
                  /* Default cond rule sets if_true to the next NOP matrix
                   * Invert this behaviour.
                   */
                  rw_yyvsp[-1].mtx->cond.if_false = rw_yyvsp[-1].mtx->cond.if_true;
                  rw_yyvsp[-1].mtx->cond.if_true = rw_yyvsp[-5].mtx;
                  rw_yyval.mtx = mtx_cur();

                  /* Fixup possible breaks */
                  loop_fixup(loop_last->lp_break, rw_yyval.mtx);
                  /* Fixup possible continues */
                  loop_fixup(loop_last->lp_cont, rw_yyvsp[-3].mtx);
                  loop_pop();
          ;
    break;}
case 40:
#line 1022 "rewrite.y"
{
                  if (!loop_last) {
                          grad_log_loc(L_ERR, &locus,
				       "%s",
				       _("nothing to break from"));
                          errcnt++;
                          YYERROR;
                  }

                  rw_yyval.mtx = mtx_jump();
                  rw_yyval.mtx->jump.link = (MTX*)loop_last->lp_break;
                  loop_last->lp_break = (JUMP_MTX*)rw_yyval.mtx;
          ;
    break;}
case 41:
#line 1036 "rewrite.y"
{
                  if (!loop_last) {
                          grad_log_loc(L_ERR, &locus,
				       "%s",
				       _("nothing to continue"));
                          errcnt++;
                          YYERROR;
                  }
                  rw_yyval.mtx = mtx_jump();
                  rw_yyval.mtx->jump.link = (MTX*)loop_last->lp_cont;
                  loop_last->lp_cont = (JUMP_MTX*)rw_yyval.mtx;
          ;
    break;}
case 42:
#line 1049 "rewrite.y"
{
		  rw_yyval.mtx = mtx_attr_delete(rw_yyvsp[-1].attr, NULL);
	  ;
    break;}
case 43:
#line 1053 "rewrite.y"
{
		  rw_yyval.mtx = mtx_attr_delete(rw_yyvsp[-4].attr, rw_yyvsp[-2].mtx);
	  ;
    break;}
case 44:
#line 1059 "rewrite.y"
{
                  rw_yyval.mtx = mtx_nop();
                  loop_push(rw_yyval.mtx);
          ;
    break;}
case 45:
#line 1066 "rewrite.y"
{
                  rw_yyval.mtx = mtx_nop();
                  loop_push(rw_yyval.mtx);
          ;
    break;}
case 46:
#line 1073 "rewrite.y"
{
                  mtx_stop();
                  mtx_jump();
                  rw_yyval.mtx = mtx_nop();
          ;
    break;}
case 47:
#line 1081 "rewrite.y"
{
                  mtx_stop();
                  rw_yyval.mtx = mtx_cond(rw_yyvsp[-1].mtx, NULL, NULL);
                  rw_yyval.mtx->cond.if_true = mtx_nop();
          ;
    break;}
case 48:
#line 1092 "rewrite.y"
{
                  rw_yyval.mtx = mtx_const(Integer, &rw_yyvsp[0].number);
          ;
    break;}
case 49:
#line 1096 "rewrite.y"
{
                  rw_yyval.mtx = mtx_const(String, &rw_yyvsp[0].string);
          ;
    break;}
case 50:
#line 1100 "rewrite.y"
{
                  rw_yyval.mtx = mtx_ref(rw_yyvsp[0].number);
          ;
    break;}
case 51:
#line 1104 "rewrite.y"
{
                  rw_yyval.mtx = mtx_var(rw_yyvsp[0].var);
          ;
    break;}
case 52:
#line 1108 "rewrite.y"
{
                  grad_log_loc(L_ERR, &locus, _("undefined variable: %s"), rw_yyvsp[0].string);
                  errcnt++;
                  YYERROR;
          ;
    break;}
case 53:
#line 1114 "rewrite.y"
{
                  rw_yyval.mtx = mtx_asgn(rw_yyvsp[-2].var, rw_yyvsp[0].mtx);
          ;
    break;}
case 54:
#line 1118 "rewrite.y"
{
                  rw_yyval.mtx = mtx_attr(rw_yyvsp[0].attr, NULL);
          ;
    break;}
case 55:
#line 1122 "rewrite.y"
{
                  rw_yyval.mtx = mtx_attr(rw_yyvsp[-3].attr, rw_yyvsp[-1].mtx);
          ;
    break;}
case 56:
#line 1126 "rewrite.y"
{
                  rw_yyval.mtx = mtx_attr_check(rw_yyvsp[0].attr, NULL);
          ;
    break;}
case 57:
#line 1130 "rewrite.y"
{
		  rw_yyval.mtx = mtx_attr_check(rw_yyvsp[-3].attr, rw_yyvsp[-1].mtx);
	  ;
    break;}
case 58:
#line 1134 "rewrite.y"
{
                  rw_yyval.mtx = mtx_attr_asgn(rw_yyvsp[-2].attr, NULL, rw_yyvsp[0].mtx);
          ;
    break;}
case 59:
#line 1138 "rewrite.y"
{
                  rw_yyval.mtx = mtx_attr_asgn(rw_yyvsp[-5].attr, rw_yyvsp[-3].mtx, rw_yyvsp[0].mtx);
          ;
    break;}
case 60:
#line 1142 "rewrite.y"
{
                  rw_yyval.mtx = mtx_call(rw_yyvsp[-3].fun, rw_yyvsp[-1].mtx);
          ;
    break;}
case 61:
#line 1146 "rewrite.y"
{
                  rw_yyval.mtx = mtx_builtin(rw_yyvsp[-3].btin, rw_yyvsp[-1].mtx);
          ;
    break;}
case 62:
#line 1150 "rewrite.y"
{
                  rw_yyval.mtx = mtx_bin(Add, rw_yyvsp[-2].mtx, rw_yyvsp[0].mtx);
          ;
    break;}
case 63:
#line 1154 "rewrite.y"
{
                  rw_yyval.mtx = mtx_bin(Sub, rw_yyvsp[-2].mtx, rw_yyvsp[0].mtx);
          ;
    break;}
case 64:
#line 1158 "rewrite.y"
{
                  rw_yyval.mtx = mtx_bin(Mul, rw_yyvsp[-2].mtx, rw_yyvsp[0].mtx);
          ;
    break;}
case 65:
#line 1162 "rewrite.y"
{
                  rw_yyval.mtx = mtx_bin(Div, rw_yyvsp[-2].mtx, rw_yyvsp[0].mtx);
          ;
    break;}
case 66:
#line 1166 "rewrite.y"
{
                  rw_yyval.mtx = mtx_bin(Rem, rw_yyvsp[-2].mtx, rw_yyvsp[0].mtx);
          ;
    break;}
case 67:
#line 1170 "rewrite.y"
{
                  rw_yyval.mtx = mtx_bin(BOr, rw_yyvsp[-2].mtx, rw_yyvsp[0].mtx);
          ;
    break;}
case 68:
#line 1174 "rewrite.y"
{
                  rw_yyval.mtx = mtx_bin(BAnd, rw_yyvsp[-2].mtx, rw_yyvsp[0].mtx);
          ;
    break;}
case 69:
#line 1178 "rewrite.y"
{
                  rw_yyval.mtx = mtx_bin(BXor, rw_yyvsp[-2].mtx, rw_yyvsp[0].mtx);
          ;
    break;}
case 70:
#line 1182 "rewrite.y"
{
                  rw_yyval.mtx = mtx_bin(Shl, rw_yyvsp[-2].mtx, rw_yyvsp[0].mtx);
          ;
    break;}
case 71:
#line 1186 "rewrite.y"
{
                  rw_yyval.mtx = mtx_bin(Shr, rw_yyvsp[-2].mtx, rw_yyvsp[0].mtx);
          ;
    break;}
case 72:
#line 1190 "rewrite.y"
{
                  rw_yyval.mtx = mtx_bin(And, rw_yyvsp[-2].mtx, rw_yyvsp[0].mtx);
          ;
    break;}
case 73:
#line 1194 "rewrite.y"
{
                  rw_yyval.mtx = mtx_bin(Or, rw_yyvsp[-2].mtx, rw_yyvsp[0].mtx);
          ;
    break;}
case 74:
#line 1198 "rewrite.y"
{
                  rw_yyval.mtx = mtx_un(Neg, rw_yyvsp[0].mtx);
          ;
    break;}
case 75:
#line 1202 "rewrite.y"
{
                  rw_yyval.mtx = rw_yyvsp[0].mtx;
          ;
    break;}
case 76:
#line 1206 "rewrite.y"
{
                  rw_yyval.mtx = mtx_un(Not, rw_yyvsp[0].mtx);
          ;
    break;}
case 77:
#line 1210 "rewrite.y"
{
                  rw_yyval.mtx = rw_yyvsp[-1].mtx;
          ;
    break;}
case 78:
#line 1214 "rewrite.y"
{
                  rw_yyval.mtx = mtx_coerce(rw_yyvsp[-2].type, rw_yyvsp[0].mtx);
          ;
    break;}
case 79:
#line 1218 "rewrite.y"
{
                  rw_yyval.mtx = mtx_bin(Eq, rw_yyvsp[-2].mtx, rw_yyvsp[0].mtx);
          ;
    break;}
case 80:
#line 1222 "rewrite.y"
{
                  rw_yyval.mtx = mtx_bin(Ne, rw_yyvsp[-2].mtx, rw_yyvsp[0].mtx);
          ;
    break;}
case 81:
#line 1226 "rewrite.y"
{
                  rw_yyval.mtx = mtx_bin(Lt, rw_yyvsp[-2].mtx, rw_yyvsp[0].mtx);
          ;
    break;}
case 82:
#line 1230 "rewrite.y"
{
                  rw_yyval.mtx = mtx_bin(Le, rw_yyvsp[-2].mtx, rw_yyvsp[0].mtx);
          ;
    break;}
case 83:
#line 1234 "rewrite.y"
{
                  rw_yyval.mtx = mtx_bin(Gt, rw_yyvsp[-2].mtx, rw_yyvsp[0].mtx);
          ;
    break;}
case 84:
#line 1238 "rewrite.y"
{
                  rw_yyval.mtx = mtx_bin(Ge, rw_yyvsp[-2].mtx, rw_yyvsp[0].mtx);
          ;
    break;}
case 85:
#line 1242 "rewrite.y"
{
                  COMP_REGEX *rx;
                  if ((rx = compile_regexp(rw_yyvsp[0].string)) == NULL) {
                          errcnt++;
                          YYERROR;
                  }
                  rw_yyval.mtx = mtx_match(0, rw_yyvsp[-2].mtx, rx);
          ;
    break;}
case 86:
#line 1251 "rewrite.y"
{
                  COMP_REGEX *rx;
                  if ((rx = compile_regexp(rw_yyvsp[0].string)) == NULL) {
                          errcnt++;
                          YYERROR;
                  }
                  rw_yyval.mtx = mtx_match(1, rw_yyvsp[-2].mtx, rx);
          ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/bison.simple"

  rw_yyvsp -= rw_yylen;
  rw_yyssp -= rw_yylen;
#ifdef YYLSP_NEEDED
  rw_yylsp -= rw_yylen;
#endif

#if YYDEBUG != 0
  if (rw_yydebug)
    {
      short *ssp1 = rw_yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != rw_yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++rw_yyvsp = rw_yyval;

#ifdef YYLSP_NEEDED
  rw_yylsp++;
  if (rw_yylen == 0)
    {
      rw_yylsp->first_line = rw_yylloc.first_line;
      rw_yylsp->first_column = rw_yylloc.first_column;
      rw_yylsp->last_line = (rw_yylsp-1)->last_line;
      rw_yylsp->last_column = (rw_yylsp-1)->last_column;
      rw_yylsp->text = 0;
    }
  else
    {
      rw_yylsp->last_line = (rw_yylsp+rw_yylen-1)->last_line;
      rw_yylsp->last_column = (rw_yylsp+rw_yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  rw_yyn = rw_yyr1[rw_yyn];

  rw_yystate = rw_yypgoto[rw_yyn - YYNTBASE] + *rw_yyssp;
  if (rw_yystate >= 0 && rw_yystate <= YYLAST && rw_yycheck[rw_yystate] == *rw_yyssp)
    rw_yystate = rw_yytable[rw_yystate];
  else
    rw_yystate = rw_yydefgoto[rw_yyn - YYNTBASE];

  goto rw_yynewstate;

rw_yyerrlab:   /* here on detecting error */

  if (! rw_yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++rw_yynerrs;

#ifdef YYERROR_VERBOSE
      rw_yyn = rw_yypact[rw_yystate];

      if (rw_yyn > YYFLAG && rw_yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -rw_yyn if nec to avoid negative indexes in rw_yycheck.  */
	  for (x = (rw_yyn < 0 ? -rw_yyn : 0);
	       x < (sizeof(rw_yytname) / sizeof(char *)); x++)
	    if (rw_yycheck[x + rw_yyn] == x)
	      size += strlen(rw_yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (rw_yyn < 0 ? -rw_yyn : 0);
		       x < (sizeof(rw_yytname) / sizeof(char *)); x++)
		    if (rw_yycheck[x + rw_yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, rw_yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      rw_yyerror(msg);
	      free(msg);
	    }
	  else
	    rw_yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	rw_yyerror("parse error");
    }

  goto rw_yyerrlab1;
rw_yyerrlab1:   /* here on error raised explicitly by an action */

  if (rw_yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (rw_yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (rw_yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", rw_yychar, rw_yytname[rw_yychar1]);
#endif

      rw_yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  rw_yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto rw_yyerrhandle;

rw_yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  rw_yyn = rw_yydefact[rw_yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (rw_yyn) goto rw_yydefault;
#endif

rw_yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (rw_yyssp == rw_yyss) YYABORT;
  rw_yyvsp--;
  rw_yystate = *--rw_yyssp;
#ifdef YYLSP_NEEDED
  rw_yylsp--;
#endif

#if YYDEBUG != 0
  if (rw_yydebug)
    {
      short *ssp1 = rw_yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != rw_yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

rw_yyerrhandle:

  rw_yyn = rw_yypact[rw_yystate];
  if (rw_yyn == YYFLAG)
    goto rw_yyerrdefault;

  rw_yyn += YYTERROR;
  if (rw_yyn < 0 || rw_yyn > YYLAST || rw_yycheck[rw_yyn] != YYTERROR)
    goto rw_yyerrdefault;

  rw_yyn = rw_yytable[rw_yyn];
  if (rw_yyn < 0)
    {
      if (rw_yyn == YYFLAG)
	goto rw_yyerrpop;
      rw_yyn = -rw_yyn;
      goto rw_yyreduce;
    }
  else if (rw_yyn == 0)
    goto rw_yyerrpop;

  if (rw_yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (rw_yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++rw_yyvsp = rw_yylval;
#ifdef YYLSP_NEEDED
  *++rw_yylsp = rw_yylloc;
#endif

  rw_yystate = rw_yyn;
  goto rw_yynewstate;

 rw_yyacceptlab:
  /* YYACCEPT comes here.  */
  if (rw_yyfree_stacks)
    {
      free (rw_yyss);
      free (rw_yyvs);
#ifdef YYLSP_NEEDED
      free (rw_yyls);
#endif
    }
  return 0;

 rw_yyabortlab:
  /* YYABORT comes here.  */
  if (rw_yyfree_stacks)
    {
      free (rw_yyss);
      free (rw_yyvs);
#ifdef YYLSP_NEEDED
      free (rw_yyls);
#endif
    }
  return 1;
}
#line 1261 "rewrite.y"


int
rw_yyerror(char *s)
{
        grad_log_loc(L_ERR, &locus, "%s", s);
        errcnt++;
	return 0;
}


/* **************************************************************************
 * Interface functions
 */
int
parse_rewrite(char *path)
{
        locus.file = path;
        infile = fopen(locus.file, "r");
        if (!infile) {
                if (errno != ENOENT) {
                        grad_log(L_ERR|L_PERROR,
                                 _("can't open file `%s'"),
                                 locus.file);
			return -1;
                }
                return -2;
        }

	debug(1,("Loading file %s", locus.file));
        rw_code_lock();
        rw_yyeof = 0;
        locus.line = 1;
	errcnt = 0;
        regex_init();
        obstack_init(&input_stk);

        mtx_init();
        var_init();
        loop_init();
        frame_init();
        
        frame_push();
	
        rw_yyparse();

        var_free_all();
        frame_free_all();
        mtx_free_all();
                
        fclose(infile);
        obstack_free(&input_stk, NULL);
        rw_code_unlock();
        return errcnt;
}

static int
parse_rewrite_string(char *str)
{
        rw_code_lock();
	code_check();
        rw_yyeof = 0;
	locus.file = "<string>";
	locus.line = 1;
	errcnt = 0;
        regex_init();
        obstack_init(&input_stk);

        mtx_init();
        var_init();
        loop_init();
        frame_init();
        
        frame_push();
        
        if (debug_on(50))
                rw_yydebug++;

	infile = 0;
	inbuf = curp = str;
	
        rw_yyparse();

#if defined(MAINTAINER_MODE)
        if (debug_on(100))
                debug_dump_code();
#endif
        
        var_free_all();
        frame_free_all();
        mtx_free_all();
                
        obstack_free(&input_stk, NULL);
        rw_code_unlock();
        return errcnt;
}


/* **************************************************************************
 * Lexical analyzer stuff: too simple to be written in lex.
 */
static int
unput(int c)
{
	if (!c)
		return 0;
	if (infile)
		ungetc(c, infile);
	else if (curp > inbuf)
		*--curp = c;
	return c;
}

static int 
input()
{
        if (rw_yyeof)
                rw_yychar = 0;
	else if (infile) {
		if ((rw_yychar = getc(infile)) <= 0) {
			rw_yyeof++;
			rw_yychar = 0;
		}
	} else if (curp) {
		rw_yychar = *curp++;
		if (!rw_yychar)
			rw_yyeof++;
	}
        return rw_yychar;
}

static int  rw_backslash();
static int  c2d(int c);
static int  read_number();
static int  read_num(int n, int base);
static char *read_string();
static char *read_ident(int c);
static char *read_to_delim(int c);
static int  skip_to_nl();
static int c_comment();

/*
 * Convert a character to digit. Only octal, decimal and hex digits are
 * allowed. If any other character is input, c2d() returns 100, which is
 * greater than any number base allowed.
 */
int
c2d(int c)
{
        switch (c) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
                return c - '0';
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
                return c - 'A' + 16;
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
                return c - 'a' + 10;
        }
        return 100;
}

/*
 * Read a number. Usual C conventions apply. 
 */
int
read_number()
{
        int c;
        int base;
	int res;
	
        c = rw_yychar;
        if (c == '0') {
                if (input() == 'x' || rw_yychar == 'X') {
                        base = 16;
                } else {
                        base = 8;
                        unput(rw_yychar);
                }
        } else
                base = 10;

	res = read_num(c2d(c), base);
	if (base == 10 && rw_yychar == '.') {
		int n;

		for (n = 0; n < 3 && rw_yychar == '.'; n++) {
			int val;
			
			input();
			val = read_num(0, base);
			res = (res << 8) + val;
		}
		if (n != 3)
			res <<= 8 * (3-n);
	}
	return res;
}

int
read_num(int n, int base)
{
        int d;

        while (input() && (d = c2d(rw_yychar)) < 16) 
                n = n*base + d;
        unput(rw_yychar);
        return n;
}

int
rw_backslash()
{
        switch (input()) {
        case '\\':
                return '\\';
        case 'a':
                return '\a';
        case 'b':
                return '\b';
        case 'f':
                return '\f';
        case 'n':
                return '\n';
        case 'r':
                return '\r';
        case 't':
                return '\t';
        case 'e':
                return '\033';
        case '0':
                return read_number();
        case 'x':
        case 'X':
                return read_num(0, 16);
        case '(':
        case ')':
                /* Preserve regular expressions */
                unput(rw_yychar);
                rw_yychar = '\\';
        }
        return rw_yychar;
}

/*
 * Read a string up to the closing doublequote
 */
char *
read_string()
{
        while (input() && rw_yychar != '"') {
                if (rw_yychar == '\\')
                        rw_yychar = rw_backslash();
                obstack_1grow(&input_stk, rw_yychar);
        }
        obstack_1grow(&input_stk, 0);
        return obstack_finish(&input_stk);
}

/*
 * Read everything up to the given delimiter
 */
char *
read_to_delim(int c)
{
        while (input() && rw_yychar != c)
                obstack_1grow(&input_stk, rw_yychar);
        obstack_1grow(&input_stk, 0);
        return obstack_finish(&input_stk);
}

/*
 * Is `c' a part of the word?
 */
#define isword(c) (isalnum(c) || c == '_' || c == '$')

/*
 * Is `c' a whitespace character?
 */
#define isws(c) ((c) == ' ' || (c) == '\t')

/*
 * Read identifier
 */
char *
read_ident(int c)
{
        obstack_1grow(&input_stk, c);
        while (input() && isword(rw_yychar))
                obstack_1grow(&input_stk, rw_yychar);
        obstack_1grow(&input_stk, 0);
        unput(rw_yychar);
        return obstack_finish(&input_stk);
}

/*
 * Skip input up to the next newline
 */
int
skip_to_nl()
{
        while (input() && rw_yychar != '\n')
                ;
        return unput(rw_yychar);
}

/*
 * Skip a C-style comment
 */
int
c_comment()
{
        if (rw_yychar != '/')
                return 0;
        if (input() == '*') {
                size_t keep_line = locus.line;

                do {
                        while (input() != '*') {
                                if (rw_yychar == 0) {
                                        grad_log_loc(L_ERR, &locus,
		       _("unexpected EOF in comment started at line %lu"),
						     (unsigned long) keep_line);
                                        return 0;
                                } else if (rw_yychar == '\n')
                                        locus.line++;
                        }
                } while (input() != '/');
                return 1;
        }
        unput(rw_yychar);
        rw_yychar = '/';
        return 0;
}


/* Pragmatic comments */
enum pragma_handler_phase {
	pragma_begin,
	pragma_cont,
	pragma_error,
	pragma_end
};

typedef int (*pragma_handler_fp) (enum pragma_handler_phase);

static int
regex_pragma (enum pragma_handler_phase phase)
{
	int disable = 0;
	int bit;
	char *s;
	static int regexp_accum;
	
	switch (phase) {
	case pragma_begin:
		regexp_accum = 0;
		return 0;
		
	case pragma_end:
		regcomp_flags = regexp_accum;
		return 0;

	case pragma_error:
		return 0;
		
	case pragma_cont:
		break;
	}

	switch (rw_yychar) {
	case '+':
		disable = 0;
		input();
		break;

	case '-':
		disable = 1;
		input();
		break;
	}
	if (!isword(rw_yychar)) {
		grad_log_loc(L_ERR, &locus, _("Malformed pragma"));
		return 1;
	}
	
	s = read_ident(rw_yychar);

	if (strcmp (s, "extended") == 0)
		bit = REG_EXTENDED;
	else if (strcmp (s, "icase") == 0)
		bit = REG_ICASE;
	else if (strcmp (s, "newline") == 0)
		bit = REG_NEWLINE;
	else {
		grad_log_loc(L_ERR, &locus,
			     _("Unknown regexp flag: %s"), s);
		return 1;
	}

	if (disable)
		regexp_accum &= ~bit;
	else
		regexp_accum |= bit;
	return 0;
}

static pragma_handler_fp
find_pragma_handler(char *s)
{
	if (strcmp(s, "regex") == 0)
		return regex_pragma;
	return NULL;
}

static void
handle_pragma()
{
	int rc;
	pragma_handler_fp pragma_handler;
	
	while (input() && isws(rw_yychar))
		;
	if (rw_yychar == 0)
		return;
			
	pragma_handler = find_pragma_handler (read_ident(rw_yychar));
		
	if (pragma_handler) {
		pragma_handler(pragma_begin);

		do {
			while (input() && isws(rw_yychar))
				;
			if (rw_yychar == 0 || rw_yychar == '\n')
				break;
			rc = pragma_handler(pragma_cont);
		} while (rc == 0 && rw_yychar != '\n' && rw_yychar != 0);
		
		pragma_handler(rc ? pragma_error : pragma_end);
	}
}




/* Parse a 'sharp' (single-line) comment */
void
sharp_comment()
{
	while (input() && isws(rw_yychar))
		;
	if (rw_yychar == 0)
		return;
	else if (rw_yychar == '\n') {
		locus.line++;
		return;
	} else if (isword(rw_yychar)) {
		if (strcmp(read_ident(rw_yychar), "pragma") == 0)
			handle_pragma();
	}
		
	skip_to_nl();
}


#if defined(MAINTAINER_MODE)
# define DEBUG_LEX1(s) if (debug_on(60)) printf("rw_yylex: " s "\n")
# define DEBUG_LEX2(s,v) if (debug_on(60)) printf("rw_yylex: " s "\n", v)
#else
# define DEBUG_LEX1(s)
# define DEBUG_LEX2(s,v)
#endif

static grad_keyword_t rw_kw[] = {
        { "if",       IF },
        { "else",     ELSE },
        { "return",   RETURN },
        { "for",      FOR },
        { "do",       DO },
        { "while",    WHILE },
        { "break",    BREAK },
        { "continue", CONTINUE },
	{ "delete",   DELETE },
        { NULL }
};

int
rw_yylex()
{
        int nl;
        int c;
        VAR *var;
        FUNCTION *fun;
        builtin_t *btin;
        
        /* Skip whitespace and comment lines */
        do {
                nl = 0;
                while (input() && isspace(rw_yychar))
                        if (rw_yychar == '\n')
                                locus.line++;
        
                if (!rw_yychar)
                        return 0;

                if (rw_yychar == '#') {
                        sharp_comment();
                        nl = 1;
                }
        } while (nl || c_comment());

        /*
         * A regexp reference
         */
        if (rw_yychar == '\\') {
                input();
                rw_yylval.number = read_number();
                DEBUG_LEX2("REFERENCE %d", rw_yylval.number);
                return REFERENCE;
        }

        /*
         * A character
         */
        if (rw_yychar == '\'') {
                if (input() == '\\')
                        c = rw_backslash();
                else
                        c = rw_yychar;
                if (input() != '\'') {
                        grad_log_loc(L_ERR, &locus,
				     "%s",
				     _("unterminated character constant"));
                        errcnt++;
                }
                rw_yylval.number = c;
                DEBUG_LEX2("CHAR %d", c);
                return NUMBER;
        }
        
        /*
         * A number
         */
        if (isdigit(rw_yychar)) {
                rw_yylval.number = read_number();
                DEBUG_LEX2("NUMBER %d", rw_yylval.number);
                return NUMBER;
        }

        /*
         * Quoted string
         */
        if (rw_yychar == '"') {
                rw_yylval.string = read_string();
                DEBUG_LEX2("STRING %s", rw_yylval.string);
                return STRING;
        }

        /* A/V  pair reference.
           We do not allow %<number> sequences, since it would result
           in conflict with binary '%' operator.
           Thanks to Clement Gerouville for noticing.  */
        if (rw_yychar == '%') {
                grad_dict_attr_t *attr = 0;
                char *attr_name;
                
                input();
                if (rw_yychar == '[' || rw_yychar == '{') {
                        attr_name = read_to_delim(rw_yychar == '[' ? ']' : '}');
                        attr = grad_attr_name_to_dict(attr_name);
                } else {
                        unput(rw_yychar);
                        return '%';
                }
                if (!attr) {
                        grad_log_loc(L_ERR, &locus,
				     _("unknown attribute `%s'"),
				     attr_name);
                        errcnt++;
                        return BOGUS;
                }
                rw_yylval.attr = attr;
                DEBUG_LEX2("ATTR: %s", attr->name);
                return ATTR;
        }
                               
                
        /*
         * Data type or identifier
         */
        if (isword(rw_yychar)) {
                rw_yylval.string = read_ident(rw_yychar);

                if (strcmp(rw_yylval.string, "integer") == 0) {
                        DEBUG_LEX1("TYPE(Integer)");
                        rw_yylval.type = Integer;
                        return TYPE;
                } else if (strcmp(rw_yylval.string, "string") == 0) {
                        DEBUG_LEX1("TYPE(String)");
                        rw_yylval.type = String;
                        return TYPE;
                }

                if ((c = grad_xlat_keyword(rw_kw, rw_yylval.string, 0)) != 0) {
                        DEBUG_LEX2("KW: %s", rw_yylval.string);
                        return c;
                }

                if (var = var_lookup(rw_yylval.string)) {
                        DEBUG_LEX2("VARIABLE: %s", rw_yylval.string);
                        rw_yylval.var = var;
                        return VARIABLE;
                }
                
                if (fun = (FUNCTION*) grad_sym_lookup(rewrite_tab, rw_yylval.string)) {
                        DEBUG_LEX2("FUN %s", rw_yylval.string);
                        rw_yylval.fun = fun;
                        return FUN;
                }

                if (btin = builtin_lookup(rw_yylval.string)) {
                        DEBUG_LEX2("BUILTIN %s", rw_yylval.string);
                        rw_yylval.btin = btin;
                        return BUILTIN;
                }
                DEBUG_LEX2("IDENT: %s", rw_yylval.string);
                return IDENT;
        }

        /*
         * Boolean expressions
         */
        if (rw_yychar == '&' || rw_yychar == '|') {
                int c = rw_yychar;

                if (input() == c) { 
                        DEBUG_LEX2("%s", rw_yychar == '&' ? "AND" : "OR"); 
                        return rw_yychar == '&' ? AND : OR;
                }
                unput(rw_yychar);
                
                DEBUG_LEX2("%c", c); 
                return c;
        }
        
        /*
         * Comparison operator
         */
        if (strchr("<>=!", rw_yychar)) {
                int c = rw_yychar;
                if (input() == '=') {
                        switch (c) {
                        case '<':
                                DEBUG_LEX1("LE");
                                return LE;
                        case '>':
                                DEBUG_LEX1("GE");
                                return GE;
                        case '=':
                                DEBUG_LEX1("EQ");
                                return EQ;
                        case '!':
                                DEBUG_LEX1("NE");
                                return NE;
                        }
                } else if (c == rw_yychar) {
                        if (c == '<') {
                                DEBUG_LEX1("SHL");
                                return SHL;
                        }
                        if (c == '>') {
                                DEBUG_LEX1("SHR");
                                return SHR;
                        }
                        unput(rw_yychar);
                        DEBUG_LEX2("%c", rw_yychar);
                        return rw_yychar;
                } else if (rw_yychar == '~') {
                        if (c == '=') {
                                DEBUG_LEX1("MT");
                                return MT;
                        }
                        if (c == '!') {
                                DEBUG_LEX1("NM");
                                return NM;
                        }
                }
                unput(rw_yychar);
                switch (c) {
                case '<':
                        DEBUG_LEX1("LT");
                        return LT;
                case '>':
                        DEBUG_LEX1("GT");
                        return GT;
                case '!':
                        DEBUG_LEX1("NOT");
                        return NOT;
                default:
                        return c;
                }
        }

        DEBUG_LEX2("%c", rw_yychar);
        return rw_yychar;
}

void
rw_yysync()
{
        while (skip_to_nl() == '\n' && !isalpha(input()))
                locus.line++;
        unput(rw_yychar);
}


/* ****************************************************************************
 * Generalized list functions
 */
static RWLIST *_list_insert(RWLIST **first, RWLIST **last, RWLIST *prev,
			    RWLIST *obj, int before);
static RWLIST *_list_remove(RWLIST **first, RWLIST **last, RWLIST *obj);
static RWLIST *_list_append(RWLIST **first, RWLIST **last, RWLIST *obj);

#define rw_list_insert(first, last, prev, obj, before) \
 _list_insert((RWLIST**)first,(RWLIST**)last,(RWLIST*)prev,(RWLIST*)obj, before)
#define rw_list_remove(first, last, obj) \
 _list_remove((RWLIST**)first,(RWLIST**)last,(RWLIST *)obj)
#define rw_list_append(first, last, obj) \
 _list_append((RWLIST**)first, (RWLIST**)last, (RWLIST*)obj)
        
RWLIST *
_list_append(RWLIST **first, RWLIST **last, RWLIST *obj)
{
        return rw_list_insert(first, last, *last, obj, 0);
}

RWLIST *
_list_insert(RWLIST **first, RWLIST **last, RWLIST *prev, RWLIST *obj,
	     int before)
{
        RWLIST   *next;

        /*
         * No first element: initialize whole list
         */
        if (!*first) {
                *first = obj;
                if (last)
                        *last = obj;
                obj->prev = obj->next = NULL;
                return obj;
        }

        /*
         * Insert before `prev'
         */
        if (before) {
                _list_insert(first, last, prev, obj, 0);
                _list_remove(first, last, prev);
                _list_insert(first, last, obj, prev, 0);
                return obj;
        }

        /*
         * Default: insert after prev
         */
        obj->prev = prev;
        obj->next = prev->next;
        
        if (next = prev->next)
                next->prev = obj;

        prev->next = obj;
        if (last && prev == *last)
                *last = obj;

                
        return obj;
}

RWLIST *
_list_remove(RWLIST **first, RWLIST **last, RWLIST *obj)
{
        RWLIST *temp;

        if (temp = obj->prev) 
                temp->next = obj->next;
        else
                *first = obj->next;

        if (temp = obj->next)
                temp->prev = obj->prev;
        else if (last)
                *last = obj->prev;

        obj->prev = obj->next = NULL;
        
        return obj;
}


/* ****************************************************************************
 * Generalized object handling
 */

void *obj_alloc(OBUCKET *bucket);
void obj_free_all(OBUCKET *bucket);
 

void *
obj_alloc(OBUCKET *bucket)
{
        OBJECT *optr;

        optr = grad_emalloc(bucket->size);

        optr->alloc        = bucket->alloc_list;
        bucket->alloc_list = optr;
        
        return optr;
}

void
obj_free_all(OBUCKET *bucket)
{
        OBJECT *obj, *next;

        obj = bucket->alloc_list;

        while (obj) {
                next = obj->alloc;
                if (bucket->free)
                        bucket->free(obj);
                grad_free(obj);
                obj = next;
        }
        bucket->alloc_list = NULL;
}


/* **************************************************************************
 * Frames
 */

void
frame_init()
{
        frame_bkt.alloc_list = NULL;
        frame_first = frame_last = NULL;
}

void
frame_push()
{
        FRAME *this_frame = obj_alloc(&frame_bkt);

        if (!frame_last) {
                this_frame->level = 0;
                this_frame->stack_offset = 0;
        } else {
                if (frame_last->level == 0)
                        this_frame->stack_offset = 1;
                else
                        this_frame->stack_offset = frame_last->stack_offset;
                this_frame->level = frame_last->level + 1;
        } 
        rw_list_append(&frame_first, &frame_last, this_frame);
}

void
frame_pop()
{
        rw_list_remove(&frame_first, &frame_last, frame_last);
}

void
frame_update_alloc()
{
        FRAME *this_frame = frame_last;

        if (this_frame->stack_offset > function->stack_alloc)
                function->stack_alloc = this_frame->stack_offset;
}

void
frame_free_all()
{
        obj_free_all(&frame_bkt);
        frame_first = frame_last = NULL;
}

void
frame_unwind_all()
{
        while (frame_last)
                rw_list_remove(&frame_first, &frame_last, frame_last);
        frame_push();
}


/* **************************************************************************
 * Loops
 */

void
loop_init()
{
        loop_bkt.alloc_list = NULL;
        loop_first = loop_last = NULL;
}

void
loop_free_all()
{
        obj_free_all(&loop_bkt);
        loop_first = loop_last = NULL;
}

void
loop_unwind_all()
{
        loop_first = loop_last = NULL;
}

/*ARGSUSED*/
void
loop_push(MTX *mtx)
{
        LOOP *this_loop = obj_alloc(&loop_bkt);
        rw_list_append(&loop_first, &loop_last, this_loop);
}

void
loop_pop()
{
        rw_list_remove(&loop_first, &loop_last, loop_last);
}

void
loop_fixup(JUMP_MTX *list, MTX *target)
{
        JUMP_MTX *jp;

        for (jp = list; jp; jp = (JUMP_MTX*)jp->link)
                jp->dest = target;
}


/* **************************************************************************
 * Variables
 */
OBUCKET var_bucket = { sizeof(VAR), NULL };

void
var_init()
{
        var_bucket.alloc_list = NULL;
        var_first = var_last = NULL;
}

VAR *
var_alloc(Datatype type, char *name, int grow)
{
        VAR *var;

        var = (VAR*) obj_alloc(&var_bucket);
        rw_list_append(&var_first, &var_last, var);

        /* Initialize fields */
        var->name     = name;
        var->datatype = type; 
        var->level    = curframe->level;
        var->offset   = curframe->stack_offset;
        curframe->stack_offset += grow;

        return var;
}

void
var_unwind_level()
{
        int cnt = 0;
        
        while (var_last && var_last->level == curframe->level) {
                rw_list_remove(&var_first, &var_last, var_last);
                cnt++;
        }

        if (cnt)
                frame_update_alloc();
}

void
var_unwind_all()
{
        while (var_last)
                rw_list_remove(&var_first, &var_last, var_last);
}

void
var_type(Datatype type, VAR *var)
{
        for (; var; var = var->dcllink)
                var->datatype = type;
}

void
var_free_all()
{
        obj_free_all(&var_bucket);
        var_first = var_last = NULL;
}

VAR *
var_lookup(char *name)
{
        VAR *var;

        var = var_last;
        while (var && strcmp(var->name, name))
                var = var->prev;
        return var;
}


/* **************************************************************************
 * Matrix generation
 */
OBUCKET mtx_bucket = { sizeof(MTX), NULL };
#if defined(MAINTAINER_MODE)
int mtx_current_id ;
#endif

/*
 * Insert a matrix into list
 */
#define mtx_remove(mtx) rw_list_remove(&mtx_first, &mtx_last, mtx)
#define mtx_append(mtx) rw_list_append(&mtx_first, &mtx_last, mtx)

void
mtx_insert(MTX *prev, MTX *mtx)
{
        MTX *up;

        rw_list_insert(&mtx_first, &mtx_last, prev, mtx, 0);
        if (up = prev->gen.uplink) {
                switch (up->gen.type) {
                case Unary:
                        up->un.arg = mtx;
                        break;
                case Binary:
                        if (up->bin.arg[0] == prev)
                                up->bin.arg[0] = mtx;
                        else
                                up->bin.arg[1] = mtx;
                        break;
                case Return:
                        up->ret.expr = mtx;
                        break;
                default:
                        /*should not happen*/
                        break;
                }
        }
}

void
mtx_init()
{
        mtx_bucket.alloc_list = NULL;
        mtx_first = mtx_last = NULL;
}

void
mtx_unwind_all()
{
        while (mtx_last)
                rw_list_remove(&mtx_first, &mtx_last, mtx_last);
}

void
mtx_free_all()
{
        obj_free_all(&mtx_bucket);
        mtx_first = mtx_last = NULL;
}

MTX *
mtx_cur()
{
        return mtx_last;
}

MTX *
mtx_frame(Mtxtype type, stkoff_t stksize)
{
        FRAME_MTX *mtx = (FRAME_MTX *)mtx_alloc(type);
        mtx_append(mtx);
        mtx->stacksize = stksize;
        return (MTX*)mtx;
}

MTX *
mtx_nop()
{
        MTX *mtx = mtx_alloc(Nop);
        mtx_append(mtx);
        return mtx;
}

MTX *
mtx_jump()
{
        MTX *mtx = mtx_alloc(Jump);
        mtx_append(mtx);
        return mtx;
}

MTX *
mtx_stop()
{
        MTX *mtx = mtx_alloc(Stop);
        mtx_append(mtx);
        return mtx;
}

MTX *
mtx_pop()
{
        MTX *mtx = mtx_alloc(Pop);
        mtx_append(mtx);
        return mtx;
}
        

MTX *
mtx_return(MTX *arg)
{
        MTX *mtx = mtx_alloc(Return);

        mtx_append(mtx);
        mtx->ret.expr = arg;
        arg->gen.uplink = (MTX*)mtx;
        return (MTX*)mtx;
}

/*
 * Allocate a matrix of given type and append it to the list
 */
MTX *
mtx_alloc(Mtxtype type)
{
        MTX *mtx = obj_alloc(&mtx_bucket);

        mtx->gen.type  = type;
        mtx->gen.loc   = locus;
#if defined(MAINTAINER_MODE)
        mtx->gen.id    = mtx_current_id++;
#endif
        return mtx;
}

/*
 * Create a Constant matrix
 */
MTX *
mtx_const(Datatype type, void *data)
{
        CONST_MTX *mtx = (CONST_MTX *)mtx_alloc(Constant);
        
        mtx_append(mtx);
        mtx->datatype = type;
        switch (type) {
        case Integer:
                mtx->datum.ival = *(int*)data;
                break;
		
        case String:
                mtx->datum.sval = *(char**)data;
		break;
		
	default:
		grad_insist_fail("unknown data type");
        }
        return (MTX*)mtx;
}

/*
 * Create a Reference matrix
 */
MTX *
mtx_ref(int num)
{
        MATCHREF_MTX *mtx = (MATCHREF_MTX*)mtx_alloc(Matchref);
        mtx_append(mtx);
        mtx->datatype = String;
        mtx->num = num;
        return (MTX*)mtx;
}

MTX *
mtx_var(VAR *var)
{
        VAR_MTX *mtx = (VAR_MTX*)mtx_alloc(Variable);
        mtx_append(mtx);
        mtx->datatype = var->datatype; 
        mtx->var = var;
        return (MTX*)mtx;
}

MTX *
mtx_asgn(VAR *var, MTX *arg)
{
        ASGN_MTX *mtx = (ASGN_MTX*)mtx_alloc(Asgn);

        mtx_append(mtx);
        if (var->datatype != arg->gen.datatype)
                coerce(arg, var->datatype);
        mtx->datatype = var->datatype;
        mtx->lval = var;
        mtx->arg  = arg;
        return (MTX*)mtx;
}


Datatype
attr_datatype(int type)
{
        switch (type) {
        case GRAD_TYPE_STRING:
        case GRAD_TYPE_DATE:
                return String;
        case GRAD_TYPE_INTEGER:
        case GRAD_TYPE_IPADDR:
                return Integer;
        default:
                grad_insist_fail("unknown attribute type");
        }
        /*NOTREACHED*/
}

MTX *
mtx_attr(grad_dict_attr_t *attr, MTX *index)
{
        ATTR_MTX *mtx = (ATTR_MTX*)mtx_alloc(Attr);
        mtx_append(mtx);
        mtx->attrno   = attr->value;
        mtx->datatype = attr_datatype(attr->type);
	mtx->index = index;
        return (MTX*)mtx;
}

MTX *
mtx_attr_check(grad_dict_attr_t *attr,	MTX *index)
{
        ATTR_MTX *mtx = (ATTR_MTX*)mtx_alloc(Attr_check);
        mtx_append(mtx);
        mtx->attrno   = attr->value;
        mtx->datatype = Integer;
	mtx->index = index;
        return (MTX*)mtx;
}


void
rw_coercion_warning(Datatype from, Datatype to, char *pref)
{
	grad_log_loc(L_WARN, &locus,
		     _("%s implicit coercion %s %s"),
		     pref ? pref : "",
		     datatype_str_abl(from),
		     datatype_str_acc(to));
}


MTX *
mtx_attr_asgn(grad_dict_attr_t *attr, MTX *index, MTX *rval)
{
        ATTR_MTX *mtx = (ATTR_MTX*)mtx_alloc(Attr_asgn);
        mtx_append(mtx);
        mtx->attrno   = attr->value;
        mtx->datatype = attr_datatype(attr->type);
        if (rval->gen.datatype != mtx->datatype) {
		rw_coercion_warning(rval->gen.datatype, mtx->datatype, NULL);
                rval = coerce(rval, mtx->datatype);
        }
	mtx->index = index;
        mtx->rval = rval;
        return (MTX*)mtx;
}

MTX *
mtx_attr_delete(grad_dict_attr_t *attr, MTX *index)
{
        ATTR_MTX *mtx = (ATTR_MTX*)mtx_alloc(Attr_delete);
        mtx_append(mtx);
        mtx->attrno   = attr->value;
        mtx->datatype = attr_datatype(attr->type);
	mtx->index = index;
        return (MTX*)mtx;
}

MTX *
mtx_bin(Bopcode opcode, MTX *arg1, MTX *arg2)
{
        BIN_MTX *mtx = (BIN_MTX*)mtx_alloc(Binary);

        mtx_append(mtx);
        if (arg1->gen.datatype != arg2->gen.datatype) {
		rw_coercion_warning(String, Integer, NULL);
                if (arg1->gen.datatype == String)
                        coerce(arg1, Integer);
                else
                        coerce(arg2, Integer);
        }

        switch (arg1->gen.datatype) {
        case String:
                switch (opcode) {
                case Add:
                        mtx->datatype = String;
                        break;
                case Eq:
                case Ne:
                case Lt:
                case Le:
                case Gt:
                case Ge:
                        mtx->datatype = Integer;
                        break;
                default:
                        grad_log_loc(L_ERR, &locus,
				     "%s",
				     _("operation not applicable to strings"));
                        errcnt++;
                        return (MTX*)mtx;
                }
                break;
                
        case Integer:
                mtx->datatype = Integer;
		break;

	default:
		grad_insist_fail("unknown data type");
        }

        mtx->opcode = opcode;
        mtx->arg[0] = arg1;
        mtx->arg[1] = arg2;
        arg1->gen.uplink = arg2->gen.uplink = (MTX*)mtx;
        return (MTX*)mtx;
}

MTX *
mtx_un(Uopcode opcode, MTX *arg)
{
        UN_MTX *mtx = (UN_MTX*)mtx_alloc(Unary);

        mtx_append(mtx);
        if (arg->gen.datatype != Integer) {
		rw_coercion_warning(String, Integer, NULL);
                coerce(arg, Integer);
        }
        mtx->datatype = Integer;
        mtx->opcode = opcode;
        mtx->arg = arg;
        arg->gen.uplink = (MTX*)mtx;
        return (MTX*)mtx;
}

MTX *
mtx_match(int negated, MTX *arg, COMP_REGEX *rx)
{
        MATCH_MTX *mtx = (MATCH_MTX*)mtx_alloc(Match);

        mtx_append(mtx);
        if (arg->gen.datatype != String) {
		rw_coercion_warning(Integer, String, NULL);
                coerce(arg, String);
        }
        mtx->datatype = Integer;
        mtx->negated = negated;
        mtx->arg = arg;
        mtx->rx  = rx;
        return (MTX*)mtx;
}

MTX *
mtx_cond(MTX *cond, MTX *if_true, MTX *if_false)
{
        COND_MTX *mtx = (COND_MTX*)mtx_alloc(Cond);

        mtx_append(mtx);
        mtx->expr = cond;
        mtx->if_true   = if_true;
        mtx->if_false  = if_false;
        return (MTX*)mtx;
}

MTX *
mtx_coerce(Datatype type, MTX *arg)
{
        if (type == arg->gen.datatype)
                return mtx_cur();
        return coerce(arg, type);
}       

MTX *
coerce(MTX *arg, Datatype type)
{
        COERCE_MTX *mtx = (COERCE_MTX*)mtx_alloc(Coercion);

        mtx_insert(arg, (MTX*) mtx);
        mtx->datatype = type;
        mtx->arg = arg;
        return (MTX*)mtx;
}

MTX *
mtx_call(FUNCTION *fun, MTX *args)
{
        MTX       *argp;
        CALL_MTX  *call;
        PARAMETER *parmp;
        int       argn;
        
        /*
         * Test the number and types of arguments. Insert reasonable
         * typecasts.
         */
        argn = 0;
        argp = args;
        parmp = fun->parm;
        while (argp && parmp) {
                if (argp->gen.datatype != parmp->datatype) {
			char buf[24];
			snprintf(buf, sizeof buf, _("(argument %d)"), argn);
			rw_coercion_warning(argp->gen.datatype,
					    parmp->datatype, buf);
                        coerce(argp, parmp->datatype);
                }
                argn++;
                argp  = argp->gen.arglink;
                parmp = parmp->next;
        }

        /*
         * Note that the argument count mismatch is not an error!
         */
        if (argp) {
                grad_log_loc(L_ERR, &locus,
			     _("too many arguments in call to %s"),
			     fun->name);
		errcnt++;
        } else if (parmp) {
                grad_log_loc(L_ERR, &locus,
			     _("too few arguments in call to %s"),
			     fun->name);
		errcnt++;
        }

        call = (CALL_MTX*) mtx_alloc(Call);
        mtx_append((MTX*)call);
        
        call->datatype = fun->rettype;
        call->fun  = fun;
        call->args = args; 
        call->nargs = argn;
        
        return (MTX*) call;
}

MTX *
mtx_builtin(builtin_t *bin, MTX *args)
{
        MTX          *argp;
        BTIN_MTX     *call;
        int          argn;
        char         *parmp;
        Datatype     type;
        /*
         * Test the number and types of arguments. Insert reasonable
         * typecasts.
         */
        argn = 0;
        argp = args;
        parmp = bin->parms;
        
        while (argp && parmp) {
                switch (parmp[0]) {
                case 'i':
                        type = Integer;
                        break;
                case 's':
                        type = String;
                        break;
                default:
                        grad_insist_fail("malformed builtin");
                }

                if (argp->gen.datatype != type) {
			char buf[24];
			snprintf(buf, sizeof buf, _("(argument %d)"), argn);
			rw_coercion_warning(argp->gen.datatype, type, buf);
                        coerce(argp, type);
                }
                argn++;
                argp  = argp->gen.arglink;
                parmp++;
        }

        if (argp) {
                grad_log_loc(L_ERR, &locus,
			     _("too many arguments in call to %s"),
			     bin->name);
                errcnt++;
        } else if (*parmp) {
                grad_log_loc(L_ERR, &locus,
			     _("too few arguments in call to %s"),
			     bin->name);
                errcnt++;
        }

        call = (BTIN_MTX*) mtx_alloc(Builtin);
        mtx_append((MTX*)call);
        
        call->datatype = bin->rettype;
        call->fun  = bin->handler;
        call->args = args; 
        call->nargs = argn;
        
        return (MTX*) call;
}


/* ****************************************************************************
 * Code optimizer (rudimentary)
 */

const char *
datatype_str_nom(Datatype type)
{
        switch (type) {
        case Undefined:
                return _("Undefined");
        case Integer:
                return _("integer");
        case String:
                return _("string");
        default:
                return _("UNKNOWN");
        }
}

const char *
datatype_str_abl(Datatype type)
{
        switch (type) {
        case Undefined:
                return _("from Undefined");
        case Integer:
                return _("from integer");
        case String:
                return _("from string");
        default:
                return _("from UNKNOWN");
        }
}

const char *
datatype_str_acc(Datatype type)
{
        switch (type) {
        case Undefined:
                return _("to Undefined");
        case Integer:
                return _("to integer");
        case String:
                return _("to string");
        default:
                return _("to UNKNOWN");
        }
}

FILE *
debug_open_file()
{
        FILE *fp;
        char *path;
        
        path = grad_mkfilename(radlog_dir, "radius.mtx");
        if ((fp = fopen(path, "a")) == NULL) {
                grad_log(L_ERR|L_PERROR,
                         _("can't open file `%s'"),
                         path);
        }
        grad_free(path);
        return fp;
}

#if defined(MAINTAINER_MODE)

static void debug_print_datum(FILE *fp, Datatype type,  Datum *datum);
static void debug_print_var(FILE *fp, VAR *var);
static void debug_print_unary(FILE *fp, UN_MTX *mtx);
static void debug_print_binary(FILE *fp, BIN_MTX *mtx);
static void debug_print_mtxlist();

static char *b_opstr[] = {
        "Eq",
        "Ne",
        "Lt",
        "Le",
        "Gt",
        "Ge",
        "&",
        "^",
        "|",
        "And",
        "Or",
        "Shl",
        "Shr",
        "Add",
        "Sub",
        "Mul",
        "Div",
        "Rem",
};

static char *u_opstr[] = {
        "Neg",
        "Not"
};

#define LINK(m) (m ? m->gen.id : 0)

void
debug_print_datum(FILE *fp, Datatype type, Datum *datum)
{
        fprintf(fp, "%3.3s ", datatype_str_nom(type));
        switch (type) {
        case Integer:
                fprintf(fp, "%d", datum->ival);
                break;
		
        case String:
                fprintf(fp, "%s", datum->sval);
		break;
		
	default:
		grad_insist_fail("unknown data type");
        }
}

void
debug_print_var(FILE *fp, VAR *var)
{
        fprintf(fp, "%3.3s %s L:%d S:%d",
                datatype_str_nom(var->datatype),
                var->name,
                var->level,
                var->offset);
        if (var->constant) {
                fprintf(fp, "CONST ");
                debug_print_datum(fp, var->datatype, &var->datum);
        }
}

void
debug_print_unary(FILE *fp, UN_MTX *mtx)
{
        fprintf(fp, "OP:%s M:%d",
                u_opstr[mtx->opcode], LINK(mtx->arg));
}

void
debug_print_binary(FILE *fp, BIN_MTX *mtx)
{
        fprintf(fp, "OP:%s M1:%d M2:%d",
                b_opstr[mtx->opcode],
                LINK(mtx->arg[0]),
                LINK(mtx->arg[1]));
}


void
debug_print_mtxlist(char *s)
{
        FILE *fp;
        MTX  *mtx, *tmp;
        
        if ((fp = debug_open_file()) == NULL) 
                return;

        #define CASE(c) case c: fprintf(fp, "%-10.10s", #c);

        fprintf(fp, "%s\n", s);
        for (mtx = mtx_first; mtx; mtx = mtx->gen.next) {
                fprintf(fp, "%4d: %4d %4d ",
                        mtx->gen.id,
                        LINK(mtx->gen.prev),
                        LINK(mtx->gen.next));
                switch (mtx->gen.type) {
                CASE (Generic)
                        break;
                CASE (Nop)
                        break;
                CASE (Enter)
                        fprintf(fp, "%3.3s %d",
                                "",
                                mtx->frame.stacksize);
                        break;
                CASE (Leave)
                        fprintf(fp, "%3.3s %d",
                                "",
                                mtx->frame.stacksize);
                        break;
                CASE (Stop)
                        break;
                CASE (Constant)
                        debug_print_datum(fp, mtx->cnst.datatype,
                                          &mtx->cnst.datum);
                        break;
                CASE (Matchref)
                        fprintf(fp, "%3.3s %d",
                                datatype_str_nom(String),
                                mtx->ref.num);
                        break;
                CASE (Variable)
                        debug_print_var(fp, mtx->var.var);
                        break;
                CASE (Unary)
                        fprintf(fp, "%3.3s ", datatype_str_nom(mtx->gen.datatype));
                        debug_print_unary(fp, &mtx->un);
                        break;
                CASE (Binary)
                        fprintf(fp, "%3.3s ", datatype_str_nom(mtx->gen.datatype));
                        debug_print_binary(fp, &mtx->bin);
                        break;
                CASE (Cond)
                        fprintf(fp, "%3.3s ", "");
                        fprintf(fp, "C:%4d T:%4d F:%4d",
                                LINK(mtx->cond.expr),
                                LINK(mtx->cond.if_true),
                                LINK(mtx->cond.if_false));
                        break;
                CASE (Asgn)
                        fprintf(fp, "%3.3s ",
                                datatype_str_nom(mtx->gen.datatype));
                        fprintf(fp, "V:%s,%d,%d M:%4d",
                                mtx->asgn.lval->name,
                                mtx->asgn.lval->level,
                                mtx->asgn.lval->offset,
                                LINK(mtx->asgn.arg));
                                break;
                CASE (Match)
                        fprintf(fp, "    N:%1d M:%4d RX:%p",
                                mtx->match.negated,
                                LINK(mtx->match.arg),
                                mtx->match.rx);
                        break; 
                CASE (Coercion)
                        fprintf(fp, "%3.3s M:%4d",
                                datatype_str_nom(mtx->coerce.datatype),
                                LINK(mtx->coerce.arg));
                        break;
                CASE (Return)
                        fprintf(fp, "%3.3s M:%4d",
                                datatype_str_nom(mtx->ret.expr->gen.datatype),
                                LINK(mtx->ret.expr));
                        break;
                CASE (Jump)
                        fprintf(fp, "%3.3s M:%4d",
                                "",
                                LINK(mtx->jump.dest));
                        break;
                CASE (Branch)
                        fprintf(fp, "%3.3s M:%4d",
                                mtx->branch.cond ? "NE" : "EQ",
                                LINK(mtx->branch.dest));
                        break;
                CASE (Call)
                        fprintf(fp, "%3.3s F:%s, A:%d:",
                                datatype_str_nom(mtx->call.datatype),
                                mtx->call.fun->name,
                                mtx->call.fun->nparm);
                        for (tmp = mtx->call.args; tmp; tmp = tmp->gen.arglink)
                                fprintf(fp, "%d,", tmp->gen.id);
                        break;

                CASE(Builtin)
                        fprintf(fp, "%3.3s F:%p, A:%d:",
                                datatype_str_nom(mtx->btin.datatype),
                                mtx->btin.fun,
                                mtx->btin.nargs);
                        for (tmp = mtx->btin.args; tmp; tmp = tmp->gen.arglink)
                                fprintf(fp, "%d,", tmp->gen.id);
                        break;

                CASE (Pop)
                        break;

                CASE (Pusha)
                        break;

                CASE (Popa)
                        break;
                
                CASE (Attr)
                        fprintf(fp, "%3.3s A:%d I:%d",
                                datatype_str_nom(mtx->gen.datatype),
                                mtx->attr.attrno,
				mtx->attr.index ? mtx->attr.index->gen.id : 0);
                        break;

                CASE (Attr_check)
                        fprintf(fp, "%3.3s A:%d I:%d",
                                datatype_str_nom(mtx->gen.datatype),
                                mtx->attr.attrno,
				mtx->attr.index ? mtx->attr.index->gen.id : 0);
                        break;
                        
                CASE (Attr_asgn)
                        fprintf(fp, "%3.3s A:%d I:%d M:%d",
                                datatype_str_nom(mtx->gen.datatype),
                                mtx->attr.attrno,
				mtx->attr.index ? mtx->attr.index->gen.id : 0,
				LINK(mtx->attr.rval));
                        break;
                        
		CASE (Attr_delete)
			fprintf(fp, "%3.3s A:%d I:%d",
				datatype_str_nom(mtx->gen.datatype),
				mtx->attr.attrno,
				mtx->attr.index ? mtx->attr.index->gen.id : 0);
		        break;
 
                default:
                        fprintf(fp, "UNKNOWN: %d", mtx->gen.type);
                }
                fprintf(fp, "\n");
        }                       
        
        fclose(fp);
}

void
debug_print_function()
{
        FILE      *fp;
        PARAMETER *parm;
        int        n;
        
        if ((fp = debug_open_file()) == NULL) 
                return;

        fprintf(fp, "FUNCTION: %s\n", function->name);
        fprintf(fp, "RETURNS : %s\n", datatype_str_nom(function->rettype));
        fprintf(fp, "NPARMS  : %d\n", function->nparm);
        fprintf(fp, "PARMS   :\n");

        for (parm = function->parm, n = 0; parm; parm = parm->next, n++) 
                fprintf(fp, "    %4d: %s at %4d\n",
                        n, datatype_str_nom(parm->datatype),
                        parm->offset);
        
        fclose(fp);
}

#endif /* MAINTAINER_MODE */
        
#if defined(MAINTAINER_MODE)
# define DEBUG_MTX(c) if (debug_on(30)) debug_print_mtxlist(c);
# define DEBUG_FUN()  if (debug_on(25)) debug_print_function();
#else
# define DEBUG_MTX(c) 
# define DEBUG_FUN()
#endif

static void pass1();
static int pass2_unary(MTX *mtx);
static int pass2_binary(MTX *mtx);

void
pass1()
{
        MTX *mtx;
        MTX *end;
        
        /*
         * Create an entry matrix
         */
        mtx = mtx_alloc(Enter);
        rw_list_insert(&mtx_first, &mtx_last, mtx_first, mtx, 1);
        mtx->frame.stacksize = function->stack_alloc;
        
        /*
         * Provide a default return statement if necessary
         */
        if (mtx_last->gen.type != Return) {
                Datum datum;
                grad_log_loc(L_WARN, &mtx_last->gen.loc,
			     _("missing return statement"));

                switch (function->rettype) {
                case Integer:
                        datum.ival = 0;
                        break;
			
                case String:
                        datum.sval = "";
			break;

		default:
			grad_insist_fail("Unknown data type");
                }
                mtx_const(function->rettype, &datum);
                mtx_frame(Leave, function->stack_alloc);
        } else {
                mtx_last->gen.type = Leave;
                mtx_last->frame.stacksize = function->stack_alloc;
        }

        /*
         * Insert a no-op matrix before the `leave' one
         */
        end = mtx_alloc(Nop);
        rw_list_insert(&mtx_first, &mtx_last, mtx_last, end, 1);
        
        for (mtx = mtx_first; mtx; mtx = mtx->gen.next) {
                if (mtx->gen.type == Return) {
                        if (mtx->ret.expr->gen.datatype != function->rettype) {
				rw_coercion_warning(
					mtx->ret.expr->gen.datatype,
					function->rettype, NULL);
                                coerce(mtx->ret.expr, function->rettype);
                        }
                        mtx->gen.type = Jump;
                        mtx->jump.dest = end;
                }
        }
}
        
/*
 * Second pass: elimination of constant sub-expressions
 */

/*
 * Perform immediate unary calculations
 */
int
pass2_unary(MTX *mtx)
{
        MTX *arg = mtx->un.arg;
        
        switch (mtx->un.opcode) {
        case Not:
                arg->cnst.datum.ival = !arg->cnst.datum.ival;
                break;
		
        case Neg:
                arg->cnst.datum.ival = -arg->cnst.datum.ival;
                break;

	default:
		grad_insist_fail("Unexpected opcode");
        }
        mtx->gen.type = Constant;
        mtx->cnst.datum = arg->cnst.datum;
        mtx_remove(arg);
        return 0;
}

/*
 * Perform immediate binary computations
 */
int
pass2_binary(MTX *mtx)
{
        MTX *arg0 = mtx->bin.arg[0];
        MTX *arg1 = mtx->bin.arg[1];
        Datum dat;
        
        switch (mtx->bin.opcode) {
        case Eq:
                dat.ival = arg0->cnst.datum.ival == arg1->cnst.datum.ival;
                break;
		
        case Ne:
                dat.ival = arg0->cnst.datum.ival != arg1->cnst.datum.ival;
                break;
		
        case Lt:
                dat.ival = arg0->cnst.datum.ival < arg1->cnst.datum.ival;
                break;
		
        case Le:
                dat.ival = arg0->cnst.datum.ival <= arg1->cnst.datum.ival;
                break;
		
        case Gt:
                dat.ival = arg0->cnst.datum.ival > arg1->cnst.datum.ival;
                break;
		
        case Ge:
                dat.ival = arg0->cnst.datum.ival >= arg1->cnst.datum.ival;
                break;
		
        case BAnd:
                dat.ival = arg0->cnst.datum.ival & arg1->cnst.datum.ival;
                break;
		
        case BOr:
                dat.ival = arg0->cnst.datum.ival | arg1->cnst.datum.ival;
                break;
		
        case BXor:
                dat.ival = arg0->cnst.datum.ival ^ arg1->cnst.datum.ival;
                break;
		
        case And:
                dat.ival = arg0->cnst.datum.ival && arg1->cnst.datum.ival;
                break;
		
        case Or:
                dat.ival = arg0->cnst.datum.ival || arg1->cnst.datum.ival;
                break;
		
        case Shl:
                dat.ival = arg0->cnst.datum.ival << arg1->cnst.datum.ival;
                break;
		
        case Shr:
                dat.ival = arg0->cnst.datum.ival >> arg1->cnst.datum.ival;
                break;
		
        case Add:
                dat.ival = arg0->cnst.datum.ival + arg1->cnst.datum.ival;
                break;
		
        case Sub:
                dat.ival = arg0->cnst.datum.ival - arg1->cnst.datum.ival;
                break;
		
        case Mul:
                dat.ival = arg0->cnst.datum.ival * arg1->cnst.datum.ival;
                break;
		
        case Div:
                if (arg1->cnst.datum.ival == 0) {
                        grad_log_loc(L_ERR, &arg1->cnst.loc,
				     _("divide by zero"));
                        errcnt++;
                } else
                        dat.ival =
                                arg0->cnst.datum.ival / arg1->cnst.datum.ival;
                break;
		
        case Rem:
                if (arg1->cnst.datum.ival == 0) {
                        grad_log_loc(L_ERR, &arg1->cnst.loc,
				     _("divide by zero"));
                        errcnt++;
                } else
                        dat.ival =
                                arg0->cnst.datum.ival % arg1->cnst.datum.ival;
                break;

	default:
		grad_insist_fail("Unexpected opcode");
        }
        mtx->gen.type = Constant;
        mtx->cnst.datum = dat;
        mtx_remove(arg0);
        mtx_remove(arg1);
        return 0;
}

MTX *
mtx_branch(int cond, MTX *target)
{
        MTX *nop = mtx_alloc(Nop);
        MTX *mtx = mtx_alloc(Branch);
        mtx_insert(target, nop);
        mtx->branch.cond = cond;
        mtx->branch.dest = nop;
        return mtx;
}

void
mtx_bool(MTX *mtx)
{
        MTX *j_mtx, *p, *p1;

        /* Insert after first operand:
	   popa
	   pusha
	   pusha      ;; Duplicate tos value
	   j?e   L10
	   popa       ;; Pop up the unneded value */

	p = mtx_alloc(Popa);
	mtx_insert(mtx->bin.arg[0], p);
	p1 = mtx_alloc(Pusha);
	mtx_insert(p, p1);
	p = mtx_alloc(Pusha);
	mtx_insert(p1, p);
        j_mtx = mtx_branch(mtx->bin.opcode == Or, mtx);
        mtx_insert(p, j_mtx);
	p1 = mtx_alloc(Popa);
	mtx_insert(j_mtx, p1);
        /* Remove the op matrix
	   Note that the mtx->cond.expr is not correct after this
	   operation, but this does not affect the functionality */
        mtx_remove(mtx);
}

/*
 * Second optimization pass: immediate computations
 */
int
pass2()
{
        MTX *mtx, *next;
        int optcnt;
        int errcnt = 0;
        
        do {
                optcnt = 0;
                mtx = mtx_first;
                while (mtx) {
                        next = mtx->gen.next;
                        switch (mtx->gen.type) {
                        case Unary:
                                if (mtx->un.arg->gen.type != Constant)
                                        break;
                                if (pass2_unary(mtx))
                                        errcnt++;
                                else
                                        optcnt++;
                                break;
                        
                        case Binary:
                                if (mtx->bin.arg[0]->gen.type == Constant
				    && mtx->bin.arg[1]->gen.type == Constant) {
                                        switch (mtx->bin.datatype) {
                                        case Integer:
                                                if (pass2_binary(mtx))
                                                        errcnt++;
                                                else
                                                        optcnt++;
                                                break;
						
                                        case String:
                                                /*NO STRING OPS SO FAR */;
					        break;

					default:
						grad_insist_fail("Unknown data type");
                                        }
                                } else if (mtx->bin.opcode == And
					   || mtx->bin.opcode == Or) {
                                        mtx_bool(mtx);
                                }
                                break;
                                /*FIXME: ADD `if (1)'/`if 0' evaluation */
                        case Jump:
                                if (mtx->jump.dest == mtx->jump.next)
                                        mtx_remove(mtx);
				break;

			case Attr:
			case Attr_asgn:
			case Attr_check:
			case Attr_delete:
				/*FIXME: the rw_attr.0 functions should
				  expect an immediate value after the
				  attribute number */
				break;

			default:
				break;
                        }
                        mtx = next;
                }
        } while (errcnt == 0 && optcnt > 0);
        return errcnt;
}

int
optimize()
{
        DEBUG_FUN();
        DEBUG_MTX("on entry to optimize");
        pass1();
        DEBUG_MTX("after first pass");
        if (pass2())
                return -1;
        DEBUG_MTX("after second pass (immediate computations)");
        return 0;
}       


/* ****************************************************************************
 * Code generator
 */


static INSTR *rw_code;          /* Code segment */
static pctr_t rw_pc;            /* PC when compiling the code */
static size_t rw_codesize;      /* Length of code segment */ 

void
code_check()
{
        if (rw_code == NULL) {
                rw_codesize  = 4096;
                rw_code  = grad_emalloc(rw_codesize * sizeof(rw_code[0]));
        }
}

void
code_init()
{
	code_check();
        /* code cell #0 is the default return address */
	rw_code[0] = 0;
	rw_pc = 1;
}

#if defined(MAINTAINER_MODE)
void
debug_dump_code()
{
        FILE    *fp;
        pctr_t  pc;
        int     i;
        
        if ((fp = debug_open_file()) == NULL)
                return;
        fprintf(fp, "Code size: %d\n", rw_codesize);
        fprintf(fp, "Code dump:\n");

        pc = 0;
        do {
                fprintf(fp, "%4d:", pc);
                for (i = 0; i < 8 && pc < rw_codesize; i++, pc++)
                        fprintf(fp, " %8x", (u_int) rw_code[pc]);
                fprintf(fp, "\n");
        } while (pc < rw_codesize);
        
        fclose(fp);
}
#endif
/*
 * Runtime function prototypes
 */
static int pushn(RWSTYPE n);
static int cpopn(RWSTYPE *np);
static RWSTYPE popn();
static void checkpop(int cnt);
static int pushref(char *str, int from, int to);
static char *heap_reserve(int size);
static void pushs(RWSTYPE *sptr, int len);
static void pushstr(const char *str, int len);

static void rw_pushn();
static void rw_pushs();
static void rw_pushref();
static void rw_pushv();
static void rw_int();
static void rw_string();
static void rw_eq();
static void rw_ne();
static void rw_lt();
static void rw_le();
static void rw_gt();
static void rw_ge();
static void rw_eqs();
static void rw_nes();
static void rw_lts();
static void rw_les();
static void rw_gts();
static void rw_ges();
static void rw_b_xor();
static void rw_b_and();
static void rw_b_or();
static void rw_shl();
static void rw_shr();
static void rw_add();
static void rw_sub();
static void rw_mul();
static void rw_div();
static void rw_rem();
static void rw_not();
static void rw_neg();
static void rw_asgn();
static void rw_enter();
static void rw_leave();
static void rw_match();
static void rw_jmp();
static void rw_jne();
static void rw_je();
static void rw_adds();
static void rw_adjstk();
static void rw_popn();
static void rw_pusha();
static void rw_popa();
static void rw_call();
static void rw_builtin();
static void rw_attrs();
static void rw_attrs0();
static void rw_attrn();
static void rw_attrn0();
static void rw_attrcheck();
static void rw_attrcheck0();
static void rw_attrasgn();
static void rw_attrasgn0();
static void rw_attr_delete();
static void rw_attr_delete0();

INSTR bin_codetab[] = {
        rw_eq,              
        rw_ne,
        rw_lt,
        rw_le,
        rw_gt,
        rw_ge,
        rw_b_and,
        rw_b_xor,
        rw_b_or,
        NULL,
        NULL,
        rw_shl,
        rw_shr,
        rw_add,
        rw_sub,
        rw_mul,
        rw_div,
        rw_rem,
};

INSTR bin_string_codetab[] = {
        rw_eqs,                      
        rw_nes,                      
        rw_lts,                      
        rw_les,                      
        rw_gts,                      
        rw_ges,                      
        NULL,                        
        NULL,                        
        NULL,                        
        NULL,                        
        NULL,                        
        NULL,                        
        NULL,                        
        rw_adds,                     
        NULL,                        
        NULL,                        
        NULL,                        
        NULL                         
};                                   

INSTR coerce_tab[] = {
        NULL,
        rw_int,
        rw_string
};

static void check_codesize(int delta);
static int  code(INSTR instr);
static int  data(int val);
static int data_str(char *ptr);
static void add_target(NOP_MTX *mtx, pctr_t pc);


void
add_target(NOP_MTX *mtx, pctr_t pc)
{
        TGT_MTX *tgt = (TGT_MTX *)mtx_alloc(Target);
        tgt->next = (MTX*)mtx->tgt;
        mtx->tgt = tgt;
        tgt->pc = pc;
}

void
fixup_target(NOP_MTX *mtx, pctr_t pc)
{
        TGT_MTX   *tgt;
        
        for (tgt = (TGT_MTX*)mtx->tgt; tgt; tgt = (TGT_MTX*)tgt->next) 
                rw_code[tgt->pc] = (INSTR)pc;
        mtx->tgt = NULL;
}

pctr_t
codegen()
{
        MTX       *mtx;

        function->entry = rw_pc;
        for (mtx = mtx_first; mtx; mtx = mtx->gen.next) {
                switch (mtx->gen.type) {
                case Generic:
                case Return:
                default:
                        grad_log(L_CRIT,
                                 "INTERNAL ERROR: codegen stumbled accross generic matrix!");
                        errcnt++;
                        return 0;
                case Nop:
                        /* Fix-up the references */
                        fixup_target(&mtx->nop, rw_pc);
                        mtx->nop.pc = rw_pc;
                        break;
                case Stop:
                        break;
                case Enter:
                        code(rw_enter);
                        data(mtx->frame.stacksize);
                        break;
                case Leave:
                        code(rw_leave);
                        break;
                case Constant:
                        switch (mtx->cnst.datatype) {
                        case Integer:
                                code(rw_pushn);
                                data(mtx->cnst.datum.ival);
                                break;
				
                        case String:
                                code(rw_pushs);
                                data_str(mtx->cnst.datum.sval);
                                break;

			default:
				grad_insist_fail("Unknown data type");
                        }
                        break;
                case Matchref:
                        code(rw_pushref);
                        data(mtx->ref.num);
                        break;
                case Variable:
                        /* Variable dereference.
                         */
                        code(rw_pushv);
                        data(mtx->var.var->offset);
                        break;
                case Unary:
                        switch (mtx->un.opcode) {
                        case Not:
                                code(rw_not);
                                break;
				
                        case Neg:
                                code(rw_neg);
                                break;

			default:
				grad_insist_fail("Unexpected opcode");
                        }
                        break;
                case Binary:
                        if (mtx->bin.arg[0]->gen.datatype == String)
                                code(bin_string_codetab[mtx->bin.opcode]);
                        else
                                code(bin_codetab[mtx->bin.opcode]);
                        break;
                case Cond:
                        /*FIXME: this needs optimization */
                        code(rw_jne);
                        add_target(&mtx->cond.if_true->nop, rw_pc);
                        code(NULL);
                        if (mtx->cond.if_false) {
                                code(rw_jmp);
                                add_target(&mtx->cond.if_false->nop, rw_pc);
                                code(NULL);
                        }
                        break;
                        
                case Asgn:
                        code(rw_asgn);
                        data(mtx->asgn.lval->offset);
                        break;
                        
                case Match:
                        code(rw_match);
                        code((INSTR)mtx->match.rx);
                        if (mtx->match.negated)
                                code(rw_not);
                        break;
                        
                case Coercion:
                        code(coerce_tab[mtx->coerce.datatype]);
                        break;
                        
                case Jump:
                        code(rw_jmp);
                        add_target(&mtx->jump.dest->nop, rw_pc);
                        code(NULL);
                        break;

                case Branch:
                        code(mtx->branch.cond ? rw_jne : rw_je);
                        add_target(&mtx->branch.dest->nop, rw_pc);
                        code(NULL);
                        break;
                        
                case Call:
                        code(rw_call);
                        code((INSTR) mtx->call.fun->entry);
                        code(rw_adjstk);
                        data(mtx->call.nargs);
                        break;

                case Builtin:
                        code(rw_builtin);
                        code(mtx->btin.fun);
                        code(rw_adjstk);
                        data(mtx->btin.nargs);
                        break;

                case Pop:
                        code(rw_popn);
                        break;

                case Popa:
                        code(rw_popa);
                        break;
                        
                case Pusha:
                        code(rw_pusha);
                        break;
                        
                case Attr:
                        switch (mtx->attr.datatype) {
                        case Integer:
				if (mtx->attr.index)
					code(rw_attrn);
				else
					code(rw_attrn0);
                                break;
				
                        case String:
				if (mtx->attr.index)
					code(rw_attrs);
				else
					code(rw_attrs0);
                                break;

			default:
				grad_insist_fail("Unknown data type");
                        }
                        data(mtx->attr.attrno);
                        break;

                case Attr_check:
			if (mtx->attr.index) 
				code(rw_attrcheck);
			else
				code(rw_attrcheck0);
                        data(mtx->attr.attrno);
                        break;
                        
                case Attr_asgn:
			if (mtx->attr.index)
				code(rw_attrasgn);
			else
				code(rw_attrasgn0);
                        data(mtx->attr.attrno);
                        break;
                                
		case Attr_delete:
			if (mtx->attr.index)
				code(rw_attr_delete);
			else
				code(rw_attr_delete0);
			data(mtx->attr.attrno);
			break;
                }
        }

        /*
         * Second pass: fixup backward references
         */
        for (mtx = mtx_first; mtx; mtx = mtx->gen.next) {
                if (mtx->gen.type == Nop)
                        fixup_target(&mtx->nop, mtx->nop.pc);
        }
        
#if defined(MAINTAINER_MODE)    
        if (debug_on(25)) {
                FILE *fp = debug_open_file();
                fprintf(fp, "entry: %d, size %d\n",
                        function->entry, rw_pc - function->entry);
                fclose(fp);
        }
#endif  
        return function->entry;
}

void
check_codesize(int delta)
{
        if (rw_pc + delta >= rw_codesize) {
                INSTR *p = grad_emalloc((rw_codesize + 4096) * sizeof(rw_code[0]));
                memcpy(p, rw_code, rw_codesize * sizeof(rw_code[0]));
                grad_free(rw_code);
                rw_code = p;
                rw_codesize += 4096;
        }
}

int
code(INSTR instr)
{
        check_codesize(1);
        rw_code[rw_pc] = instr;
        return rw_pc++;
}

int
data(int val)
{
        return code((INSTR)(RWSTYPE)val);
}

int
data_str(char *ptr)
{
        int  len   = strlen(ptr) + 1;
        RWSTYPE delta = (len + sizeof(rw_code[0])) / sizeof(rw_code[0]);
        
        check_codesize(delta+1);
        rw_code[rw_pc++] = (INSTR)delta;
        memcpy(rw_code + rw_pc, ptr, len);
        rw_pc += delta;
        return rw_pc;
}
        

/* ****************************************************************************
 * Regular expressions
 */

COMP_REGEX *
rx_alloc(regex_t *regex, int nmatch)
{
        COMP_REGEX *rx;

        rx = grad_emalloc(sizeof(*rx));
        rx->regex  = *regex;
        rx->nmatch = nmatch;
        rw_list_insert(&function->rx_list, NULL, function->rx_list, rx, 1);
        return rx;
}

void
rx_free(COMP_REGEX *rx)
{
        COMP_REGEX *next;

        while (rx) {
                next = rx->next;
                regfree(&rx->regex);
                grad_free(rx);
                rx = next;
        }
}

COMP_REGEX *
compile_regexp(char *str)
{
        char     *p;
        regex_t  regex;
        int      nmatch;
        
        int rc = regcomp(&regex, str, regcomp_flags);
        if (rc) {
                char errbuf[512];
                regerror(rc, &regex, errbuf, sizeof(errbuf));
                grad_log_loc(L_ERR, &locus,
			     _("regexp error: %s"),
			     errbuf);
                return NULL;
        }
        /* count the number of matches */
        nmatch = 0;
        for (p = str; *p; ) {
                if (*p == '\\')
                        if (p[1] == '(') {
                                nmatch++;
                                p += 2;
                                continue;
                        }
                p++;
        }
        
        return rx_alloc(&regex, nmatch);
}

void
function_delete()
{
        if (function) {
                grad_symtab_delete(rewrite_tab, (grad_symbol_t*)function);
                function_cleanup();
        }
}

void
function_cleanup()
{
        function = NULL;
}


/* ****************************************************************************
 * Runtime functions
 */

/*
 * Push a number on stack
 */
int
pushn(RWSTYPE n)
{
        if (mach.st >= mach.ht) {
                /*FIXME: gc();*/
                debug(1, ("st=%d, ht=%d", mach.st, mach.ht));
                rw_error(_("out of pushdown space"));
        }
        mach.stack[mach.st++] = n;
        return 0;
}

/*
 * Push a string on stack
 */
void
pushs(RWSTYPE *sptr, int len)
{
        if (mach.ht - len <= mach.st) {
                /* Heap overrun: */
                /*gc(); */
                rw_error(_("heap overrun"));
        }

        while (len)
                mach.stack[mach.ht--] = sptr[--len];

        pushn((RWSTYPE) (mach.stack + mach.ht + 1));
}

void
pushstr(const char *str, int len)
{
        char *s;
        strncpy(s = heap_reserve(len+1), str, len);
        s[len] = 0;
        pushn((RWSTYPE)s);
}

char *
heap_reserve(int size)
{
        int  len = (size + sizeof(mach.stack[0])) / sizeof(mach.stack[0]);

        if (mach.ht - len <= mach.st) {
                /* Heap overrun: */
                gc();
                if (mach.ht - len <= mach.st) 
                        rw_error(_("heap overrun"));
        }
        mach.ht -= len;
        return (char*)(mach.stack + mach.ht--);
}


/* Temporary space functions */
char *
temp_space_create()
{
	return (char*)(mach.stack + mach.st);
}

void
temp_space_copy(char **baseptr, char *text, size_t size)
{
        size_t len = (size + sizeof(mach.stack[0])) / sizeof(mach.stack[0]);
	if (*baseptr + len >= (char*)(mach.stack + mach.ht))
		rw_error(_("out of heap space"));
	memcpy(*baseptr, text, size);
	*baseptr += size;
}

char *
temp_space_fix(char *end)
{
	size_t len, size;
	char *base = (char*)(mach.stack + mach.st);

	size = end - base;
	len = (size + sizeof(mach.stack[0])) / sizeof(mach.stack[0]);
        mach.ht -= len;
	memmove(mach.stack + mach.ht, base, size);
        return (char*)(mach.stack + mach.ht--);
}


/*
 * Pop number from stack and store into NP.
 */
int
cpopn(RWSTYPE *np)
{
        if (mach.st <= 0) {
                rw_error(_("out of popup"));
        }
        *np = mach.stack[--mach.st];
        return 0;
}

/*
 * Pop the number from stack without error checking. checkpop() function
 * should be called before calling this one.
 */
RWSTYPE
popn()
{
        return mach.stack[--mach.st];
}

RWSTYPE
tos()
{
        return mach.stack[mach.st-1];
}

/*
 * Check if the stack contains at list CNT elements.
 */
void
checkpop(int cnt)
{
        if (mach.st < cnt)
		rw_error(_("out of popup"));
}
        
/*
 * Push a backreference value on stack.
 * Arguments: str     --    input string
 *            from    --    start of reference in string
 *            to      --    end of reference in string
 */
int
pushref(char *str, int from, int to)
{
        int len = to - from + 1;
        char *s = heap_reserve(len);
        char *p = s;
        
        while (from < to) 
                *p++ = str[from++];
        *p = 0;
        return pushn((RWSTYPE)s);
}

/*
 * Create a stack frame and enter the function
 */
void
enter(int n)
{
        pushn(mach.sb);
        mach.sb = mach.st;
        mach.st += n;
}

/*
 * Destroy the stack frame and leave the function
 */
void
leave()
{
        /* Save return value */
        mach.rA = popn();
        /* Restore stack frame */
        mach.st = mach.sb;
        mach.sb = popn();
        mach.pc = (pctr_t) popn();
}

RWSTYPE
getarg(int num)
{
        return mach.stack[mach.sb - (STACK_BASE + num)];
}


/* ****************************************************************************
 * Instructions
 */

static RWSTYPE nil = 0;

static int
rw_error(const char *msg)
{
        grad_log(L_ERR,
	         "%s: %s",
                 _("rewrite runtime error"), msg);
        longjmp(mach.jmp, 1);
        /*NOTREACHED*/
}
                
static int
rw_error_free(char *msg)
{
        grad_log(L_ERR,
	         "%s: %s",
                 _("rewrite runtime error"), msg);
	free(msg);
        longjmp(mach.jmp, 1);
        /*NOTREACHED*/
}
                
void
rw_call()
{
        pctr_t  pc = (pctr_t) rw_code[mach.pc++];
        pushn(mach.pc); /* save return address */
        mach.pc = pc;
}

void
rw_adjstk()
{
        int delta = (int) rw_code[mach.pc++];
        mach.st -= delta;
        pushn(mach.rA);   /* Push the return back on stack */
}

void
rw_enter()
{
        /*FIXME: runtime checking */
        int n = (int) rw_code[mach.pc++];
        enter(n);
}

void
rw_leave()
{
        leave();
}

/*
 * Push a number on stack
 */
void
rw_pushn()
{
        RWSTYPE n = (RWSTYPE) rw_code[mach.pc++];
        pushn(n);
}

/*
 * Push a reference value on stack
 */
void
rw_pushref()
{
        int i = (int) rw_code[mach.pc++];

        pushref(mach.sA, mach.pmatch[i].rm_so, mach.pmatch[i].rm_eo);
}

/*
 * Push a variable on stack
 */
void
rw_pushv()
{
        stkoff_t n = (stkoff_t) rw_code[mach.pc++];

        pushn(mach.stack[mach.sb + n]);
}

void
rw_pushs()
{
        int   len = (int) rw_code[mach.pc++];
        RWSTYPE *sptr = (RWSTYPE*) (rw_code + mach.pc);

        mach.pc += len;
        pushs(sptr, len);
}

/*
 * Assign a value to a variable
 */
void
rw_asgn()
{
        stkoff_t off = (stkoff_t) rw_code[mach.pc++];
        RWSTYPE n;

        cpopn(&n);
        
        mach.stack[mach.sb + off] = n;
        pushn(n);
}

void
assert_request_presence()
{
	if (!mach.req)
		rw_error(_("no request supplied"));
}

/* Check if the A/V pair is supplied in the request
 */
void
rw_attrcheck0()
{
        int attr = (int) rw_code[mach.pc++];

	pushn(grad_avl_find(AVPLIST(&mach), attr) != NULL);
}

void
rw_attrcheck()
{
        int attr = (int) rw_code[mach.pc++];
	RWSTYPE index;
 
	cpopn(&index);
	pushn(grad_avl_find_n(AVPLIST(&mach), attr, index) != NULL);
}

/*
 * Assign a value to an A/V pair
 */
void
attrasgn_internal(int attr, grad_avp_t *pair, RWSTYPE val)
{
	assert_request_presence();
	if (!pair) {
                 pair = grad_avp_create(attr);
                 if (!pair)
                        rw_error(_("can't create A/V pair"));
                 grad_avl_add_pair(&mach.req->avlist, pair);
         }
		
	switch (pair->type) {
	case GRAD_TYPE_STRING:
	case GRAD_TYPE_DATE:
		grad_string_replace(&pair->avp_strvalue, (char*)val);
		pair->avp_strlength = strlen((char*) val);
		break;
		
	case GRAD_TYPE_INTEGER:
	case GRAD_TYPE_IPADDR:
		pair->avp_lvalue = val;
		break;
	}
	
	pushn(val);
}

void
rw_attrasgn0()
{
        int attr = (int) rw_code[mach.pc++];
        RWSTYPE val;
        
        cpopn(&val);
	attrasgn_internal(attr, grad_avl_find(AVPLIST(&mach), attr), val);
}

void
rw_attrasgn()
{
        int attr = (int) rw_code[mach.pc++];
        RWSTYPE val;
	RWSTYPE index;
 
        cpopn(&val);
	cpopn(&index);
	attrasgn_internal(attr, grad_avl_find_n(AVPLIST(&mach), attr, index),
			  val);
}

void
rw_attrs0()
{
        int attr = (int) rw_code[mach.pc++];
        grad_avp_t *pair;
        
        if ((pair = grad_avl_find(AVPLIST(&mach), attr)) == NULL) 
                pushs(&nil, 1);
        else if (pair->prop & GRAD_AP_ENCRYPT) {
		char string[GRAD_STRING_LENGTH+1];
		int len;
		req_decrypt_password(string, mach.req, pair);
		len = strlen(string);
		pushstr(string, len);
	} else
                pushstr(pair->avp_strvalue, pair->avp_strlength);
}

void
rw_attrn0()
{
        int attr = (int) rw_code[mach.pc++];
        grad_avp_t *pair;

        if ((pair = grad_avl_find(AVPLIST(&mach), attr)) == NULL)
                pushn(0);
        else
                pushn(pair->avp_lvalue);
}

void
rw_attrs()
{
        int attr = (int) rw_code[mach.pc++];
        grad_avp_t *pair;
	RWSTYPE index;

	cpopn(&index);
        if ((pair = grad_avl_find_n(AVPLIST(&mach), attr, index)) == NULL) 
                pushs(&nil, 1);
        else
                pushstr(pair->avp_strvalue, pair->avp_strlength);
}

void
rw_attrn()
{
        int attr = (int) rw_code[mach.pc++];
        grad_avp_t *pair;
	RWSTYPE index;

	cpopn(&index);
        if ((pair = grad_avl_find_n(AVPLIST(&mach), attr, index)) == NULL)
                pushn(0);
        else
                pushn(pair->avp_lvalue);
}

void
rw_attr_delete0()
{
        int attr = (int) rw_code[mach.pc++];
	grad_avl_delete(&mach.req->avlist, attr);
}

void
rw_attr_delete()
{
        int attr = (int) rw_code[mach.pc++];
	RWSTYPE index;

	assert_request_presence();
	cpopn(&index);
	grad_avl_delete_n(&mach.req->avlist, attr, index);
}

/*
 * Pop (and discard) a value from stack
 */
void
rw_popn()
{
        RWSTYPE n;
        cpopn(&n);
}

/*
 * Pop a value from stack into the accumulator
 */
void
rw_popa()
{
        cpopn(&mach.rA);
}

/*
 * Push accumulator on stack
 */
void
rw_pusha()
{
        pushn(mach.rA);
}

/*
 * String concatenation
 */
void
rw_adds()
{
        char *s1, *s2, *s;

        checkpop(2);
        s2 = (char*)popn();
        s1 = (char*)popn();
        s = heap_reserve(strlen(s1) + strlen(s2) + 1);
        strcat(strcpy(s, s1), s2);
        pushn((RWSTYPE)s);
}

/*
 * Unary negation
 */
void
rw_neg()
{
        checkpop(1);
        pushn(-popn());
}

/*
 * Bitwise operations
 */
void
rw_b_and()
{
        int n1, n2;

        checkpop(2);
        n2 = popn();
        n1 = popn();
        pushn(n1 & n2);
}

void
rw_b_or()
{
        int n1, n2;

        checkpop(2);
        n2 = popn();
        n1 = popn();
        pushn(n1 | n2);
}

void
rw_b_xor()
{
        int n1, n2;

        checkpop(2);
        n2 = popn();
        n1 = popn();
        pushn(n1 ^ n2);
}

void
rw_shl()
{
        int n1, n2;

        checkpop(2);
        n2 = popn();
        n1 = popn();
        pushn(n1 << n2);
}

void
rw_shr()
{
        int n1, n2;

        checkpop(2);
        n2 = popn();
        n1 = popn();
        pushn(n1 >> n2);
}

/*
 * Addition
 */
void
rw_add()
{
        int n1, n2;

        checkpop(2);
        n2 = popn();
        n1 = popn();
        pushn(n1+n2);
}

/*
 * Subtraction
 */
void
rw_sub()
{
        int n1, n2;

        checkpop(2);
        n2 = popn();
        n1 = popn();
        pushn(n1-n2);
}

/*
 * Multiplication
 */
void
rw_mul()
{
        int n1, n2;

        checkpop(2);
        n2 = popn();
        n1 = popn();
        pushn(n1*n2);
}

/*
 * Division
 */
void
rw_div()
{
        int n1, n2;

        checkpop(2);
        n2 = popn();
        n1 = popn();
        if (n2 == 0) 
                rw_error(_("division by zero!"));
        pushn(n1/n2);
}

/*
 * Remainder
 */
void
rw_rem()
{
        int n1, n2;

        checkpop(2);
        n2 = popn();
        n1 = popn();
        if (n2 == 0) 
                rw_error(_("division by zero!"));
        pushn(n1%n2);
}

void
rw_int()
{
        char *s = (char *)popn();
        pushn(strtol(s, NULL, 0));
}

void
rw_string()
{
        int n = popn();
        RWSTYPE buf[64];
        
        snprintf((char*)buf, sizeof(buf), "%d", n);
        pushs(buf, 64);
}

void
rw_eq()
{
        int n1, n2;

        checkpop(2);
        n2 = popn();
        n1 = popn();
        pushn(n1 == n2);
}

void
rw_ne()
{
        int n1, n2;

        checkpop(2);
        n2 = popn();
        n1 = popn();
        pushn(n1 != n2);
}

void
rw_lt()
{
        int n1, n2;

        checkpop(2);
        n2 = popn();
        n1 = popn();
        pushn(n1 < n2);
}

void
rw_le()
{
        int n1, n2;

        checkpop(2);
        n2 = popn();
        n1 = popn();
        pushn(n1 <= n2);
}

void
rw_gt()
{
        int n1, n2;

        checkpop(2);
        n2 = popn();
        n1 = popn();
        pushn(n1 > n2);
}

void
rw_ge()
{
        int n1, n2;

        checkpop(2);
        n2 = popn();
        n1 = popn();
        pushn(n1 >= n2);
}

void
rw_eqs()
{
        char *s1, *s2;

        checkpop(2);
        s2 = (char*)popn();
        s1 = (char*)popn();
        pushn(strcmp(s1, s2) == 0);
}

void
rw_nes()
{
        char *s1, *s2;

        checkpop(2);
        s2 = (char*)popn();
        s1 = (char*)popn();
        pushn(strcmp(s1, s2) != 0);
}

void
rw_lts()
{
        char *s1, *s2;

        checkpop(2);
        s2 = (char*)popn();
        s1 = (char*)popn();
        pushn(strcmp(s1, s2) < 0);
}

void
rw_les()
{
        char *s1, *s2;

        checkpop(2);
        s2 = (char*)popn();
        s1 = (char*)popn();
        pushn(strcmp(s1, s2) <= 0);
}

void
rw_gts()
{
        char *s1, *s2;

        checkpop(2);
        s2 = (char*)popn();
        s1 = (char*)popn();
        pushn(strcmp(s1, s2) > 0);
}

void
rw_ges()
{
        char *s1, *s2;

        checkpop(2);
        s2 = (char*)popn();
        s1 = (char*)popn();
        pushn(strcmp(s1, s2) >= 0);
}

void
rw_not()
{
        int n;

        checkpop(1);
        n = popn();
        pushn(!n);
}

static void
need_pmatch(size_t n)
{
	n++;
        if (mach.nmatch < n) {
                grad_free(mach.pmatch);
                mach.nmatch = n;
                mach.pmatch = grad_emalloc(n * sizeof(mach.pmatch[0]));
        }
}

void
rw_match()
{
        COMP_REGEX *rx = (COMP_REGEX *)rw_code[mach.pc++];
        char *s = (char*)popn();
        int rc;
        
	need_pmatch(rx->nmatch);
        mach.sA = s;
        
        rc = regexec(&rx->regex, mach.sA, 
                     rx->nmatch + 1, mach.pmatch, 0);
        if (rc && debug_on(1)) {
                char errbuf[512];
                regerror(rc, &rx->regex,
                         errbuf, sizeof(errbuf));
                grad_log(L_DEBUG,
		         _("rewrite regex failure: %s. Input: %s"),
                         errbuf, (char*)mach.rA);
        }
        pushn(rc == 0);
}

void
rw_jmp()
{
        pctr_t pc = (pctr_t) rw_code[mach.pc++];
        mach.pc = pc;
} 

void
rw_jne()
{
        int n;
        pctr_t pc = (pctr_t) rw_code[mach.pc++];
        
        n = popn();
        if (n != 0)
                mach.pc = pc;
}

void
rw_je()
{
        int n;
        pctr_t pc = (pctr_t) rw_code[mach.pc++];
        
        n = popn();
        if (n == 0)
                mach.pc = pc;
}

void
rw_builtin()
{
        INSTR fun = (INSTR) rw_code[mach.pc++];
        pushn(mach.pc);
        enter(0);
        fun();
        leave();
}

void
run(pctr_t pc)
{
        mach.pc = pc;
        while (rw_code[mach.pc]) {
                if (mach.pc >= rw_codesize)
                        rw_error(_("pc out of range"));
                (*(rw_code[mach.pc++]))();
        }
}


/* ****************************************************************************
 * A placeholder for the garbage collector
 */

void
gc()
{
}


/* ****************************************************************************
 * Built-in functions
 */

/*
 * integer length(string s)
 */
static void
bi_length()
{
        pushn(strlen((char*)getarg(1)));
}

/*
 * integer index(string s, integer a)
 */
static void
bi_index()
{
        char *s, *p;
        int   c;

        s = (char*) getarg(2);
        c = (int) getarg(1);
        p = strchr(s, c);
        pushn(p ? p - s : -1);
}

/*
 * integer rindex(string s, integer a)
 */
static void
bi_rindex()
{
        char *s, *p;
        int   c;

        s = (char*) getarg(2);
        c = (int) getarg(1);
        pushn((p = strrchr(s, c)) ? p - s : -1 );
}

/*
 * string substr(string s, int start, int length)
 */
static void
bi_substr()
{
        char *src, *dest;
        int   start, length;

        src    = (char*) getarg(3);
        start  = getarg(2);
        length = getarg(1);
        if (length < 0)
                length = strlen(src) - start;
        
        dest = heap_reserve(length+1);
        if (length > 0) 
                strncpy(dest, src + start, length);
        dest[length] = 0;
        pushn((RWSTYPE) dest);
}

static void
bi_field()
{
        char *str = (char*) getarg(2);
        int fn = getarg(1);
        char *s = (char*)&nil;
        int len = 1;

        while (*str && fn--) {
                /* skip initial whitespace */
                while (*str && isspace(*str))
                        str++;

                s = str;
                len = 0;
                while (*str && !isspace(*str)) {
                        str++;
                        len++;
                }
        }

	if (!*str && fn) 
		pushs(&nil, 1);
	else {
		str = heap_reserve(len+1);
		if (len) {
			memcpy(str, s, len);
			str[len] = 0;
		}
		pushn((RWSTYPE) str);
	}
}

static void
bi_logit()
{
        char *msg = (char*) getarg(1);
        grad_log(L_INFO, "%s", msg);
        pushn(0);
}

static void
bi_htonl()
{
	pushn(htonl(getarg(1)));
}

static void
bi_ntohl()
{
	pushn(ntohl(getarg(1)));
}

static void
bi_htons()
{
	pushn(htons(getarg(1) & 0xffff));
}

static void
bi_ntohs()
{
	pushn(ntohs(getarg(1) & 0xffff));
}

static void
bi_inet_ntoa()
{
	char buffer[GRAD_IPV4_STRING_LENGTH];
	char *s = grad_ip_iptostr(getarg(1), buffer);
	pushstr(s, strlen(s));
}

static void
bi_inet_aton()
{
	/* Note: inet_aton is not always present. See lib/iputils.c */
	pushn(grad_ip_strtoip((char*)getarg(1)));
}

static void
bi_tolower()
{
	char *src = (char*)getarg(1);
	char *dest;
	int i, len = strlen(src);
	
	dest = heap_reserve(len+1);
	dest[len] = 0;
	for (i = 0; i < len; i++)
		dest[i] = tolower(src[i]);
	pushn((RWSTYPE) dest);
}	

static void
bi_toupper()
{
	char *src = (char*)getarg(1);
	char *dest;
	int i, len = strlen(src);
	
	dest = heap_reserve(len+1);
	dest[len] = 0;
	for (i = 0; i < len; i++)
		dest[i] = toupper(src[i]);
	pushn((RWSTYPE) dest);
}	

static void
bi_request_code_string()
{
        int code = (int) getarg(1);
	const char *s = grad_request_code_to_name(code);
	pushstr(s, strlen(s));
}

static void
bi_request_source_ip()
{
	assert_request_presence();
	pushn((RWSTYPE) mach.req->ipaddr);
}

static void
bi_request_source_port()
{
	assert_request_presence();
	pushn((RWSTYPE) mach.req->udp_port);
}

static void
bi_request_id()
{
	assert_request_presence();
	pushn((RWSTYPE) mach.req->id);
}

static void
bi_request_code()
{
	assert_request_presence();
	pushn((RWSTYPE) mach.req->code);
}

static void
bi_nas_name()
{
        grad_nas_t *nas;
	grad_uint32_t ip = (grad_uint32_t) getarg(1);

	if ((nas = grad_nas_lookup_ip(ip)) != NULL) {
		char *s = nas->shortname[0] ? nas->shortname : nas->longname;
		pushstr(s, strlen(s));
        } else {
		char nasname[GRAD_MAX_LONGNAME];
		
		grad_ip_gethostname(ip, nasname, sizeof(nasname));
		pushstr(nasname, strlen(nasname));
	}
}

static void
bi_nas_short_name()
{
        grad_nas_t *nas;
	grad_uint32_t ip = (grad_uint32_t) getarg(1);

	if ((nas = grad_nas_lookup_ip(ip)) && nas->shortname[0]) {
		pushstr(nas->shortname, strlen(nas->shortname));
        } else {
		char nasname[GRAD_MAX_LONGNAME];
		
		grad_ip_gethostname(ip, nasname, sizeof(nasname));
		pushstr(nasname, strlen(nasname));
	}
}

static void
bi_nas_full_name()
{
        grad_nas_t *nas;
	grad_uint32_t ip = (grad_uint32_t) getarg(1);

	if ((nas = grad_nas_lookup_ip(ip)) != NULL) {
		pushstr(nas->longname, strlen(nas->longname));
        } else {
		char nasname[GRAD_MAX_LONGNAME];
		
		grad_ip_gethostname(ip, nasname, sizeof(nasname));
		pushstr(nasname, strlen(nasname));
	}
}

static void
bi_gethostbyaddr()
{
	grad_uint32_t ip = (grad_uint32_t) getarg(1);
	char nasname[GRAD_MAX_LONGNAME];
		
	grad_ip_gethostname(ip, nasname, sizeof(nasname));
	pushstr(nasname, strlen(nasname));
}

static void
bi_gethostbyname()
{
	pushn((RWSTYPE) grad_ip_gethostaddr((char *) getarg(1)));
}

static void
rw_regerror(const char *prefix, regex_t *rx, int rc)
{
	size_t sz = regerror(rc, rx, NULL, 0);
	char *errbuf = malloc(sz + strlen (prefix) + 1);
	if (!errbuf) 
		rw_error(prefix);
	else {
		strcpy (errbuf, prefix);
		regerror(rc, rx, errbuf + strlen(prefix), sz);
		rw_error_free(errbuf);
	}
}

enum subst_segment_type {
	subst_text,       /* pure text */
	subst_ref,        /* back reference (\NN) */
	subst_match       /* substitute whole match (&) */
};

struct subst_segment {
	enum subst_segment_type type;
	union {
		struct {
			char *ptr;
			size_t len; 
		} text;      /* type == subst_text */
		size_t ref;  /* type == subst_ref */
	} v;
};

static void
add_text_segment(grad_list_t *lst, char *ptr, char *end)
{
	struct subst_segment *seg;
	if (ptr >= end)
		return;
	seg = grad_emalloc(sizeof(*seg));
	seg->type = subst_text;
	seg->v.text.ptr = ptr;
	seg->v.text.len = end - ptr;
	grad_list_append(lst, seg);
}

static void
add_match_segment(grad_list_t *lst)
{
	struct subst_segment *seg = grad_emalloc(sizeof(*seg));
	seg->type = subst_match;
	grad_list_append(lst, seg);
}

static void
add_ref_segment(grad_list_t *lst, size_t ref)
{
	struct subst_segment *seg = grad_emalloc(sizeof(*seg));
	seg->type = subst_ref;
	seg->v.ref = ref;
	grad_list_append(lst, seg);
}

grad_list_t *
subst_create(char *text)
{
	char *p;
	grad_list_t *lst = grad_list_create();
	if (!lst)
		return lst;

	p = text;
	while (*p) {
		if (*p == '\\' && p[1]) {
			if (p[1] == '&') {
				add_text_segment(lst, text, p);
				text = ++p;
				p++;
			} else if (p[1] == '\\') {
				add_text_segment(lst, text, p+1);
				p += 2;
				text = p;
			} else if (isdigit(p[1])) {
				size_t ref;
				char *q;
				
				add_text_segment(lst, text, p);
				ref = strtoul(p+1, &q, 10);
				add_ref_segment(lst, ref);
				text = p = q;
			} else {
				add_text_segment(lst, text, p);
				text = ++p;
			}
		} else if (*p == '&') {
			add_text_segment(lst, text, p);
			add_match_segment(lst);
			text = ++p;
		} else
			p++;
	}
	add_text_segment(lst, text, p);
	return lst;	
}

int
seg_free(void *item, void *data ARG_UNUSED)
{
	grad_free(item);
	return 0;
}

void
subst_destroy(grad_list_t *lst)
{
	grad_list_destroy(&lst, seg_free, NULL);
}

void
subst_run(grad_list_t *subst, size_t nsub,
	  char **baseptr, char *arg)
{
	grad_iterator_t *itr = grad_iterator_create(subst);
	struct subst_segment *seg;
	
	for (seg = grad_iterator_first(itr); seg; seg = grad_iterator_next(itr)) {
		switch (seg->type) {
		case subst_text:
			temp_space_copy(baseptr,
					seg->v.text.ptr, seg->v.text.len);
			break;
			
		case subst_ref:
			if (seg->v.ref >= nsub)
				rw_error(_("Invalid backreference"));
			temp_space_copy(baseptr,
					arg + mach.pmatch[seg->v.ref].rm_so,
					mach.pmatch[seg->v.ref].rm_eo -
					  mach.pmatch[seg->v.ref].rm_so);
			break;
			    
		case subst_match:
			temp_space_copy(baseptr,
					arg + mach.pmatch[0].rm_so,
					mach.pmatch[0].rm_eo -
					  mach.pmatch[0].rm_so);
		}
	}
	grad_iterator_destroy(&itr);
}

static void
bi_gsub()
{
	char *re_str = (char*) getarg(3);
	char *repl = (char*) getarg(2);
	char *arg = (char*) getarg(1);
	char *base;
	regex_t rx;
	grad_list_t *subst;
	
        int rc = regcomp(&rx, re_str, regcomp_flags);
        if (rc) 
		rw_regerror(_("regexp compile error: "), &rx, rc);

	need_pmatch(rx.re_nsub);

	subst = subst_create(repl);
	if (!subst)
		rw_error(_("gsub: not enough memory"));
	
	base = temp_space_create();
	while (*arg
	       && regexec(&rx, arg, rx.re_nsub + 1, mach.pmatch, 0) == 0) {
		temp_space_copy(&base, arg, mach.pmatch[0].rm_so);
		subst_run(subst, rx.re_nsub + 1, &base, arg);
		arg += mach.pmatch[0].rm_eo;
		if (mach.pmatch[0].rm_eo == 0)
			arg++;
	}
	temp_space_copy(&base, arg, strlen(arg) + 1);
	subst_destroy(subst);
	regfree(&rx);

	pushn((RWSTYPE) temp_space_fix(base));
}

static void
bi_sub()
{
	char *re_str = (char*) getarg(3);
	char *repl = (char*) getarg(2);
	char *arg = (char*) getarg(1);
	char *base;
	regex_t rx;
	grad_list_t *subst;
	
        int rc = regcomp(&rx, re_str, regcomp_flags);
        if (rc) 
		rw_regerror(_("regexp compile error: "), &rx, rc);

	need_pmatch(rx.re_nsub);

	subst = subst_create(repl);
	if (!subst)
		rw_error(_("sub: not enough memory"));
	
	base = temp_space_create();
	if (regexec(&rx, arg, rx.re_nsub + 1, mach.pmatch, 0) == 0) {
		temp_space_copy(&base, arg, mach.pmatch[0].rm_so);
		subst_run(subst, rx.re_nsub + 1, &base, arg);
		arg += mach.pmatch[0].rm_eo;
	}
	temp_space_copy(&base, arg, strlen(arg) + 1);
	subst_destroy(subst);
	regfree(&rx);

	pushn((RWSTYPE) temp_space_fix(base));
}

#define ISPRINT(c) (((unsigned char)c) < 128 && (isalnum(c) || c == '-'))

static void
bi_qprn()
{
	char *s = (char*)getarg(1);
	char *p;
	size_t count;

	for (count = 0, p = s; *p; p++)
		if (!ISPRINT(*p))
			count++;

	/* Each encoded character takes 3 bytes. */
	p = heap_reserve(strlen(s) + 2*count + 1);
	
	pushn((RWSTYPE) p);
	for (; *s; s++) {
		if (ISPRINT(*s))
			*p++ = *s;
		else {
			char buf[3];
			snprintf(buf, sizeof buf, "%2X", *s);
			*p++ = '%';
			*p++ = buf[0];
			*p++ = buf[1];
		}
	}
	*p = 0;
}

static void
bi_quote_string()
{
	char *s = (char*)getarg(1);
	int quote;
	size_t len = argcv_quoted_length(s, &quote);
	char *p = heap_reserve(len + 1);

	pushn((RWSTYPE) p);
	argcv_quote_copy(p, s);
	p[len] = 0;
}

static void
bi_unquote_string()
{
	char *s = (char*)getarg(1);
	size_t len = strlen(s);
	char *p = heap_reserve(len + 1);

	pushn((RWSTYPE) p);
	argcv_unquote_copy(p, s, len);
}

static void
bi_textdomain()
{
	pushstr(default_gettext_domain, strlen (default_gettext_domain));
	grad_string_replace(&default_gettext_domain, (const char*)getarg(1));
}

static void
bi_gettext()
{
	const char *p = dgettext(default_gettext_domain,
				 (const char*)getarg(1));
	pushstr(p, strlen(p));
}

static void
bi_dgettext()
{
	const char *p = dgettext((const char*)getarg(2),
				 (const char*)getarg(1));
	pushstr(p, strlen(p));
}


static void
bi_ngettext()
{
	const char *p = dngettext(default_gettext_domain,
				  (const char*) getarg(3),
				  (const char*) getarg(2),
				  (unsigned long) getarg(1));
	pushstr(p, strlen(p));
}

static void
bi_dngettext()
{
	const char *p = dngettext((const char*) getarg(4),
		                  (const char*) getarg(3),
				  (const char*) getarg(2),
				  (unsigned long) getarg(1));
	pushstr(p, strlen(p));
}

static builtin_t builtin[] = {
        { bi_length,  "length", Integer, "s" },
	{ bi_index,   "index",  Integer, "si" },
        { bi_rindex,  "rindex", Integer, "si" },
        { bi_substr,  "substr", String,  "sii" },
        { bi_logit,   "logit",  Integer, "s" },
        { bi_field,   "field",  String,  "si" },
	{ bi_ntohl, "ntohl", Integer, "i" },
	{ bi_htonl, "htonl", Integer, "i" },
	{ bi_ntohs, "ntohs", Integer, "i" },
	{ bi_htons, "htons", Integer, "i" },
	{ bi_inet_ntoa, "inet_ntoa", String, "i" },
	{ bi_inet_aton, "inet_aton", Integer, "s" },
	{ bi_sub, "sub", String, "sss" },
	{ bi_gsub, "gsub", String, "sss" },
	{ bi_qprn, "qprn", String, "s" },
	{ bi_tolower, "tolower", String, "s" },
	{ bi_toupper, "toupper", String, "s" },
	{ bi_unquote_string, "unquote_string", String, "s" },
	{ bi_quote_string, "quote_string", String, "s" },
	{ bi_request_code_string, "request_code_string", String, "i" },
	/* i18n support */
	{ bi_gettext, "gettext", String, "s" },
	{ bi_gettext, "_", String, "s" },
	{ bi_dgettext, "dgettext", String, "ss" },
	{ bi_ngettext, "ngettext", String, "ssi" },
	{ bi_dngettext, "dngettext", String, "sssi" },
	{ bi_textdomain, "textdomain", String, "s" },
	/* Request internals */
	{ bi_request_source_ip,   "request_source_ip", Integer, "" },
	{ bi_request_source_port, "request_source_port", Integer, "" },
	{ bi_request_id, "request_id", Integer, "" },
	{ bi_request_code, "request_code", Integer, "" },
	/* Radius database */
	{ bi_nas_name, "nas_name", String, "i" },
	{ bi_nas_short_name, "nas_short_name", String, "i" },
	{ bi_nas_full_name, "nas_full_name", String, "i" },
	/* DNS lookups */
	{ bi_gethostbyaddr, "gethostbyaddr", Integer, "s" },
	{ bi_gethostbyname, "gethostbyname", String, "i" },
	{ NULL }
};

builtin_t *
builtin_lookup(char *name)
{
        int i;

        for (i = 0; builtin[i].handler; i++)
                if (strcmp(name, builtin[i].name) == 0)
                        return &builtin[i];
        return NULL;
}


/* ****************************************************************************
 * Function registering/unregistering 
 */

int
function_free(FUNCTION *f)
{
        PARAMETER *parm, *next;
        
        rx_free(f->rx_list);
        parm = f->parm;
        while (parm) {
                next = parm->next;
                grad_free(parm);
                parm = next;
        }
        return 0;
}
                
FUNCTION *
function_install(FUNCTION *fun)
{
        FUNCTION *fp;

        if (fp = (FUNCTION *)grad_sym_lookup(rewrite_tab, fun->name)) {
                grad_log_loc(L_ERR, &fun->loc,
			     _("redefinition of function %s"));
                grad_log_loc(L_ERR, &fp->loc,
			     _("previously defined here"));
                errcnt++;
                return fp;
        }  
        fp = (FUNCTION*)grad_sym_install(rewrite_tab, fun->name);
        
        fp->rettype = fun->rettype;
        fp->entry   = fun->entry;
        fp->rx_list = fun->rx_list;
        fp->nparm   = fun->nparm;        
        fp->parm    = fun->parm;
        fp->stack_alloc = fun->stack_alloc;
	fp->loc     = fun->loc;
        return fp;
}


/* ****************************************************************************
 * Runtime functions
 */

static char pair_print_prefix[] = "    ";

static void
rw_mach_init()
{
	memset(&mach, 0, sizeof(mach));

	if (!runtime_stack)
		runtime_stack = grad_emalloc(rewrite_stack_size *
					sizeof(runtime_stack[0]));
	
	mach.stack = runtime_stack;
        mach.st = 0;                      /* Stack top */
        mach.ht = rewrite_stack_size - 1; /* Heap top */

	grad_string_replace(&default_gettext_domain, PACKAGE);
}

static void
rw_mach_destroy()
{
}

FUNCTION *
rewrite_check_function(const char *name, Datatype rettype, char *typestr)
{
	int i;
	PARAMETER *p;
	
	FUNCTION *fun = (FUNCTION*) grad_sym_lookup(rewrite_tab, name);
        if (!fun) {
                grad_log(L_ERR, _("function %s not defined"), name);
                return NULL;
        }
	if (fun->rettype != rettype) {
		grad_log(L_ERR, _("function %s returns wrong data type"), name);
		return NULL;
	}

	for (i = 0, p = fun->parm; i < fun->nparm; i++, p = p->next) {
                switch (typestr[i]) {
		case 0:
			grad_log(L_ERR,
			         _("function %s takes too many arguments"),
			         name);
			return NULL;
			
                case 'i':
                        if (p->datatype != Integer) {
				grad_log(L_ERR,
				         _("function %s: argument %d must be integer"),
				         name, i+1);
				return NULL;
			}
                        break;
			
                case 's':
                        if (p->datatype != String) {
				grad_log(L_ERR,
				         _("function %s: argument %d must be string"),
				         name, i+1);
				return NULL;
			}
                        break;
			
                default:
                        grad_insist_fail("bad datatype");
                }
        }

	if (typestr[i]) {
		grad_log(L_ERR,
		         _("function %s takes too few arguments"),
		         name);
		return NULL;
	}

	return fun;
}

int
run_init(pctr_t pc, grad_request_t *request)
{
        FILE *fp;

	rw_mach_init();
        if (setjmp(mach.jmp)) {
		rw_mach_destroy();
                return -1;
	}
        
        mach.req = request;
        if (debug_on(2)) {
                fp = debug_open_file();
                fprintf(fp, "Before rewriting:\n");
                grad_avl_fprint(fp, pair_print_prefix, 1, AVPLIST(&mach));
                fclose(fp);
        }

        /* Imitate a function call */
        pushn(0);                  /* Return address */
        run(pc);                   /* call function */
        if (debug_on(2)) {
                fp = debug_open_file();
                fprintf(fp, "After rewriting\n");
                grad_avl_fprint(fp, pair_print_prefix, 1, AVPLIST(&mach));
                fclose(fp);
        }
	rw_mach_destroy();
	return 0;
}

static int
evaluate(pctr_t pc, grad_request_t *req, Datatype rettype, Datum *datum)
{
        if (run_init(pc, req))
		return -1;
	if (datum) {
		switch (rettype) {
		case Integer:   
			datum->ival = mach.rA;
			break;
			
		case String:
			datum->sval = grad_estrdup((char*) mach.rA);
			break;
			
		default:
			abort();
		}
	}
        return 0;
}

int
rewrite_invoke(Datatype rettype, void *ret,
	       const char *name, grad_request_t *request, char *typestr, ...)
{
        FILE *fp;
        va_list ap;
        FUNCTION *fun;
        int nargs;
        char *s;

        fun = rewrite_check_function(name, rettype, typestr);
	if (!fun)
		return -1;

	rw_mach_init();
        if (setjmp(mach.jmp)) {
                rw_mach_destroy();
                return -1;
        }
        
        mach.req = request;
        if (debug_on(2)) {
                fp = debug_open_file();
                fprintf(fp, "Before rewriting:\n");
                grad_avl_fprint(fp, pair_print_prefix, 1, AVPLIST(&mach));
                fclose(fp);
        }

        /* Pass arguments */
        nargs = 0;

	va_start(ap, typestr);
        while (*typestr) {
                nargs++;
                switch (*typestr++) {
                case 'i':
                        pushn(va_arg(ap, int));
                        break;
                case 's':
                        s = va_arg(ap, char*);
                        pushstr(s, strlen(s));
                        break;
                default:
                        grad_insist_fail("bad datatype");
                }
        }
        va_end(ap);

        /* Imitate a function call */
        pushn(0);                  /* Return address */
        run(fun->entry);           /* call function */
        if (debug_on(2)) {
                fp = debug_open_file();
                fprintf(fp, "After rewriting\n");
                grad_avl_fprint(fp, pair_print_prefix, 1, AVPLIST(&mach));
                fclose(fp);
        }

	switch (rettype) {
	case String:
		/* FIXME: constant return. It may not be safe if
		   rw_mach_destroy() actually does something */
		*(char**)ret = (char *)mach.rA; 
		break;

	case Integer:
		*(grad_uint32_t*)ret = mach.rA;
	}
        rw_mach_destroy();
        return 0;
}

char *
rewrite_compile(char *expr)
{
	int rc;
	FUNCTION *fun;
	char *name = grad_emalloc(strlen(expr) + 3); 

	sprintf(name, "$%s$", expr);
        fun = (FUNCTION*) grad_sym_lookup(rewrite_tab, name);
        if (!fun) {
		rc = parse_rewrite_string(expr);
		if (rc) {
			grad_free(name);
			return NULL;
		}
		function->name = name;
		function_install(function);
	}
	return name;
}

int
rewrite_interpret(char *expr, grad_request_t *req,
		  Datatype *type, Datum *datum)
{
	pctr_t save_pc = rw_pc;
	int rc;
	
	rc = parse_rewrite_string(expr);
	rw_pc = save_pc;
	if (rc)
		return rc;

	if (return_type == Undefined) {
		*type = return_type;
		return -1;
	}
	*type = return_type;

	return evaluate(rw_pc, req, return_type, datum);
}

int
rewrite_eval(char *symname, grad_request_t *req, Datatype *type, Datum *datum)
{
        FUNCTION *fun;
	
        fun = (FUNCTION*) grad_sym_lookup(rewrite_tab, symname);
        if (!fun)
		return -1;
	
	if (fun->nparm) {
		grad_log(L_ERR,
		         ngettext("function %s() requires %d parameter",
				  "function %s() requires %d parameters",
				  fun->nparm),
		         fun->name, fun->nparm);
		return -1;
	}

	if (type)
		*type = fun->rettype;
	return evaluate(fun->entry, req, fun->rettype, datum);
}
	

/* ****************************************************************************
 * Configuration
 */

static grad_list_t *source_list;        /* List of loaded source files */
static grad_list_t *rewrite_load_path;  /* Load path list */

/* Add a path to load path */
static void
rewrite_add_load_path(const char *str)
{
	if (!rewrite_load_path)
		rewrite_load_path = grad_list_create();
	grad_list_append(rewrite_load_path, grad_estrdup(str));
}

void
register_source_name(char *path)
{
	if (!source_list)
		source_list = grad_list_create();
	grad_list_append(source_list, path);
}

struct load_data {
	int rc;
	char *name;
};

/* Try to load a source file.
   ITEM is a directory name, DATA is struct load_data.
   Return 1 if the file was found (no matter was it loaded or not) */
static int
try_load(void *item, void *data)
{
	int rc = 0;
	struct load_data *lp = data;
	char *path = grad_mkfilename((char*)item, lp->name);

	lp->rc = parse_rewrite(path);
	if (lp->rc >= 0) {
		register_source_name(path);
		rc = 1;
	} else
		grad_free(path);
	return rc;
}

/* Load the given rewrite module. */
int
rewrite_load_module(char *name)
{
	int rc;
	if (name[0] == '/') {
		register_source_name(grad_estrdup(name));
		rc = parse_rewrite(name);
	} else {
		struct load_data ld;
		ld.rc = 1;
		ld.name = name;
		grad_list_iterate(rewrite_load_path, try_load, &ld);
		rc = ld.rc;
	}
	return rc;
}

static int
free_path(void *item, void *data ARG_UNUSED)
{
	grad_free(item);
	return 0;
}

static grad_list_t *source_candidate_list; /* List of modules that are to
					      be loaded */

int
rewrite_stmt_term(int finish, void *block_data, void *handler_data)
{
	if (!finish) {
		grad_symtab_clear(rewrite_tab);
		
		rw_yydebug = debug_on(50);
		grad_list_destroy(&source_list, free_path, NULL);
		grad_list_destroy(&rewrite_load_path, free_path, NULL);
		rewrite_add_load_path(radius_dir);
		rewrite_add_load_path(RADIUS_DATADIR "/rewrite");

		grad_free(runtime_stack);
		runtime_stack = NULL;
	} 
	return 0;
}

static int
rewrite_cfg_add_load_path(int argc, cfg_value_t *argv,
			  void *block_data, void *handler_data)
{
	if (argc > 2) {
		cfg_argc_error(0);
		return 0;
	}

 	if (argv[1].type != CFG_STRING) {
		cfg_type_error(CFG_STRING);
		return 0;
	}

	rewrite_add_load_path(argv[1].v.string);
	return 0;
}

static int
rewrite_cfg_load(int argc, cfg_value_t *argv,
		 void *block_data, void *handler_data)
{
	if (argc > 2) {
		cfg_argc_error(0);
		return 0;
	}

 	if (argv[1].type != CFG_STRING) {
		cfg_type_error(CFG_STRING);
		return 0;
	}

	grad_list_append(source_candidate_list, grad_estrdup(argv[1].v.string));
	return 0;
}

/* Configuration hooks and initialization */

static void
rewrite_before_config_hook(void *a ARG_UNUSED, void *b ARG_UNUSED)
{
	grad_list_destroy(&source_candidate_list, free_path, NULL);
	source_candidate_list = grad_list_create();
	code_init();
}

static int
_load_module(void *item, void *data ARG_UNUSED)
{
	if (rewrite_load_module(item) == -2)
		grad_log(L_ERR, _("file not found: %s"), item);
	return 0;
}

void
rewrite_load_all(void *a ARG_UNUSED, void *b ARG_UNUSED)
{
	if (!source_candidate_list)
		return;
	
	/* For compatibility with previous versions load the
	   file $radius_dir/rewrite, if no explicit "load" statements
	   were given */
	if (grad_list_count(source_candidate_list) == 0)
		rewrite_load_module("rewrite");
	
	grad_list_iterate(source_candidate_list, _load_module, NULL);
#if defined(MAINTAINER_MODE)
        if (debug_on(100))
                debug_dump_code();
#endif
}

void
rewrite_init()
{
	rewrite_tab = grad_symtab_create(sizeof(FUNCTION), function_free);
	radiusd_set_preconfig_hook(rewrite_before_config_hook, NULL, 0);
}


struct cfg_stmt rewrite_stmt[] = {
	{ "stack-size", CS_STMT, NULL, cfg_get_number, &rewrite_stack_size,
	  NULL, NULL },
	{ "load-path", CS_STMT, NULL, rewrite_cfg_add_load_path, NULL, NULL, NULL },
	{ "load", CS_STMT, NULL, rewrite_cfg_load, NULL, NULL, NULL },
	{ NULL, }
};

size_t
rewrite_get_stack_size()
{
	return rewrite_stack_size;
}

void
rewrite_set_stack_size(size_t s)
{
	if (s == rewrite_stack_size)
		return;
	rewrite_stack_size = s;
	grad_free(runtime_stack);
	runtime_stack = NULL;
}
				       


/* ****************************************************************************
 * Guile interface
 */
#ifdef USE_SERVER_GUILE

SCM
radscm_datum_to_scm(Datatype type, Datum datum)
{
        switch (type) {
        case Integer:
                return scm_long2num(datum.ival);

        case String:
                return scm_makfrom0str(datum.sval);

	default:
		grad_insist_fail("Unknown data type");
        }
        return SCM_UNSPECIFIED;
}

int
radscm_scm_to_ival(SCM cell, int *val)
{
        if (SCM_IMP(cell)) {
                if (SCM_INUMP(cell))  
                        *val = SCM_INUM(cell);
                else if (SCM_BIGP(cell)) 
                        *val = (grad_uint32_t) scm_i_big2dbl(cell);
                else if (SCM_CHARP(cell))
                        *val = SCM_CHAR(cell);
                else if (cell == SCM_BOOL_F)
                        *val = 0;
                else if (cell == SCM_BOOL_T)
                        *val = 1;
                else if (cell == SCM_EOL)
                        *val =0;
                else
                        return -1;
        } else {
                if (SCM_STRINGP(cell)) {
                        char *p;
                        *val = strtol(SCM_STRING_CHARS(cell), &p, 0);
                        if (*p)
                                return -1;
                } else
                        return -1;
        }
        return 0;
}

SCM
radscm_rewrite_execute(const char *func_name, SCM ARGS)
{
        char *name;
        FUNCTION *fun;
        PARAMETER *parm;
        int nargs;
        int n, rc;
        Datum datum;
        SCM cell;
        SCM FNAME;
	
        FNAME = SCM_CAR(ARGS);
        ARGS  = SCM_CDR(ARGS);
        SCM_ASSERT(SCM_NIMP(FNAME) && SCM_STRINGP(FNAME),
                   FNAME, SCM_ARG1, func_name);

        name = SCM_STRING_CHARS(FNAME);
        fun = (FUNCTION*) grad_sym_lookup(rewrite_tab, name);
        if (!fun) 
                scm_misc_error(func_name,
                               _("function ~S not defined"),
                               scm_list_1(FNAME));
	
        rw_mach_init();

        /* Pass arguments */
        nargs = 0;
        parm = fun->parm;
        
        for (cell = ARGS; cell != SCM_EOL; cell = SCM_CDR(cell), parm = parm->next) {
                SCM car = SCM_CAR(cell);

                if (++nargs > fun->nparm) {
                        rw_code_unlock();
                        scm_misc_error(func_name,
                                       _("too many arguments for ~S"),
                                       scm_list_1(FNAME));
                }

                switch (parm->datatype) {
                case Integer:
                        rc = radscm_scm_to_ival(car, &n);
                        if (!rc) 
                                pushn(n);
                        break;
                        
                case String:
                        if (SCM_NIMP(car) && SCM_STRINGP(car)) {
                                char *p = SCM_STRING_CHARS(car);
                                pushstr(p, strlen(p));
                                rc = 0;
                        } else
                                rc = 1;
			break;

		default:
			grad_insist_fail("Unknown data type");
                }

                if (rc) {
                        rw_mach_destroy();
                        scm_misc_error(func_name,
				       _("type mismatch in argument ~S(~S) in call to ~S"),
                                       scm_list_3(SCM_MAKINUM(nargs),
						  car,
						  FNAME));
                }
        }

        if (fun->nparm != nargs) {
		rw_mach_destroy();
                scm_misc_error(func_name,
                               _("too few arguments for ~S"),
                               scm_list_1(FNAME));
        }
        
        /* Imitate a function call */
        if (setjmp(mach.jmp)) {
                rw_mach_destroy();
                return SCM_BOOL_F;
        }

        pushn(0);                         /* Return address */
        run(fun->entry);                  /* call function */

        switch (fun->rettype) {
        case Integer:   
                datum.ival = mach.rA;
                break;
        case String:
                datum.sval = (char*) mach.rA;
                break;
        default:
                abort();
        }
	rw_mach_destroy();
        return radscm_datum_to_scm(fun->rettype, datum);
}


#endif

        /*HONY SOIT QUI MAL Y PENSE*/
